/* Color.c generated by valac 0.18.1, the Vala compiler
 * generated from Color.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define PLANK_DRAWING_TYPE_COLOR (plank_drawing_color_get_type ())
typedef struct _PlankDrawingColor PlankDrawingColor;

struct _PlankDrawingColor {
	gdouble R;
	gdouble G;
	gdouble B;
	gdouble A;
};



GType plank_drawing_color_get_type (void) G_GNUC_CONST;
PlankDrawingColor* plank_drawing_color_dup (const PlankDrawingColor* self);
void plank_drawing_color_free (PlankDrawingColor* self);
void plank_drawing_color_from_gdk_color (GdkColor* color, PlankDrawingColor* result);
void plank_drawing_color_to_gdk_color (PlankDrawingColor *self, GdkColor* result);
void plank_drawing_color_from_gdk_rgba (GdkRGBA* color, PlankDrawingColor* result);
void plank_drawing_color_to_gdk_rgba (PlankDrawingColor *self, GdkRGBA* result);
gboolean plank_drawing_color_equal (PlankDrawingColor *self, PlankDrawingColor* color);
void plank_drawing_color_set_hsv (PlankDrawingColor *self, gdouble h, gdouble s, gdouble v);
static void plank_drawing_color_hsv_to_rgb (gdouble h, gdouble s, gdouble v, gdouble* r, gdouble* g, gdouble* b);
void plank_drawing_color_set_hue (PlankDrawingColor *self, gdouble hue);
static void plank_drawing_color_rgb_to_hsv (gdouble r, gdouble g, gdouble b, gdouble* h, gdouble* s, gdouble* v);
void plank_drawing_color_set_sat (PlankDrawingColor *self, gdouble sat);
void plank_drawing_color_set_val (PlankDrawingColor *self, gdouble val);
void plank_drawing_color_set_alpha (PlankDrawingColor *self, gdouble alpha);
void plank_drawing_color_get_hsv (PlankDrawingColor *self, gdouble* h, gdouble* s, gdouble* v);
gdouble plank_drawing_color_get_hue (PlankDrawingColor *self);
gdouble plank_drawing_color_get_sat (PlankDrawingColor *self);
gdouble plank_drawing_color_get_val (PlankDrawingColor *self);
void plank_drawing_color_add_hue (PlankDrawingColor *self, gdouble val);
void plank_drawing_color_set_min_sat (PlankDrawingColor *self, gdouble sat);
void plank_drawing_color_set_min_value (PlankDrawingColor *self, gdouble val);
void plank_drawing_color_set_max_sat (PlankDrawingColor *self, gdouble sat);
void plank_drawing_color_set_max_val (PlankDrawingColor *self, gdouble val);
void plank_drawing_color_multiply_sat (PlankDrawingColor *self, gdouble amount);
void plank_drawing_color_brighten_val (PlankDrawingColor *self, gdouble amount);
void plank_drawing_color_darken_val (PlankDrawingColor *self, gdouble amount);
void plank_drawing_color_darken_by_sat (PlankDrawingColor *self, gdouble amount);
gchar* plank_drawing_color_to_string (PlankDrawingColor *self);
void plank_drawing_color_from_string (const gchar* s, PlankDrawingColor* result);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Creates a new color from a {@link Gdk.Color}.
 *
 * @param color the color to use
 * @return new {@link Color} based on the given one
 */
void plank_drawing_color_from_gdk_color (GdkColor* color, PlankDrawingColor* result) {
	GdkColor _tmp0_;
	guint16 _tmp1_;
	guint16 _tmp2_;
	GdkColor _tmp3_;
	guint16 _tmp4_;
	guint16 _tmp5_;
	GdkColor _tmp6_;
	guint16 _tmp7_;
	guint16 _tmp8_;
	PlankDrawingColor _tmp9_ = {0};
#line 52 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail (color != NULL);
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = *color;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = _tmp0_.red;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = G_MAXUINT16;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = *color;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = _tmp3_.green;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp5_ = G_MAXUINT16;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp6_ = *color;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp7_ = _tmp6_.blue;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = G_MAXUINT16;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_.R = ((gdouble) _tmp1_) / _tmp2_;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_.G = ((gdouble) _tmp4_) / _tmp5_;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_.B = ((gdouble) _tmp7_) / _tmp8_;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_.A = 1.0;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	*result = _tmp9_;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	return;
#line 127 "Color.c"
}


/**
 * Creates a new {@link Gdk.Color}.from this color
 *
 * @return new {@link Gdk.Color}
 */
void plank_drawing_color_to_gdk_color (PlankDrawingColor *self, GdkColor* result) {
	gdouble _tmp0_;
	guint16 _tmp1_;
	gdouble _tmp2_;
	guint16 _tmp3_;
	gdouble _tmp4_;
	guint16 _tmp5_;
	GdkColor _tmp6_ = {0};
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = (*self).R;
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = G_MAXUINT16;
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).G;
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = G_MAXUINT16;
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp5_ = G_MAXUINT16;
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp6_.pixel = (guint32) 0;
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp6_.red = (guint16) (_tmp0_ * _tmp1_);
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp6_.green = (guint16) (_tmp2_ * _tmp3_);
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp6_.blue = (guint16) (_tmp4_ * _tmp5_);
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	*result = _tmp6_;
#line 67 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	return;
#line 168 "Color.c"
}


/**
 * Creates a new color from a {@link Gdk.RGBA}.
 *
 * @param color the color to use
 * @return new {@link Color} based on the given one
 */
void plank_drawing_color_from_gdk_rgba (GdkRGBA* color, PlankDrawingColor* result) {
	GdkRGBA _tmp0_;
	gdouble _tmp1_;
	GdkRGBA _tmp2_;
	gdouble _tmp3_;
	GdkRGBA _tmp4_;
	gdouble _tmp5_;
	GdkRGBA _tmp6_;
	gdouble _tmp7_;
	PlankDrawingColor _tmp8_ = {0};
#line 79 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail (color != NULL);
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = *color;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = _tmp0_.red;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = *color;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = _tmp2_.green;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = *color;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp5_ = _tmp4_.blue;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp6_ = *color;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp7_ = _tmp6_.alpha;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_.R = _tmp1_;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_.G = _tmp3_;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_.B = _tmp5_;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_.A = _tmp7_;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	*result = _tmp8_;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	return;
#line 218 "Color.c"
}


/**
 * Creates a new {@link Gdk.RGBA}.from this color
 *
 * @return new {@link Gdk.RGBA}
 */
void plank_drawing_color_to_gdk_rgba (PlankDrawingColor *self, GdkRGBA* result) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GdkRGBA _tmp4_ = {0};
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = (*self).R;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = (*self).G;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).B;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).A;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_.red = _tmp0_;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_.green = _tmp1_;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_.blue = _tmp2_;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_.alpha = _tmp3_;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	*result = _tmp4_;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	return;
#line 253 "Color.c"
}


/**
 * Check equality with the give color
 *
 * @return whether the give color equals this color.
 */
gboolean plank_drawing_color_equal (PlankDrawingColor *self, PlankDrawingColor* color) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gdouble _tmp3_;
	PlankDrawingColor _tmp4_;
	gdouble _tmp5_;
	gboolean _tmp9_;
	gboolean _tmp13_;
	gboolean _tmp17_;
#line 99 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_val_if_fail (color != NULL, FALSE);
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).R;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = *color;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp5_ = _tmp4_.R;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (_tmp3_ == _tmp5_) {
#line 283 "Color.c"
		gdouble _tmp6_;
		PlankDrawingColor _tmp7_;
		gdouble _tmp8_;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp6_ = (*self).G;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp7_ = *color;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp8_ = _tmp7_.G;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp2_ = _tmp6_ == _tmp8_;
#line 295 "Color.c"
	} else {
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp2_ = FALSE;
#line 299 "Color.c"
	}
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = _tmp2_;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (_tmp9_) {
#line 305 "Color.c"
		gdouble _tmp10_;
		PlankDrawingColor _tmp11_;
		gdouble _tmp12_;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp10_ = (*self).B;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp11_ = *color;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp12_ = _tmp11_.B;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp1_ = _tmp10_ == _tmp12_;
#line 317 "Color.c"
	} else {
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp1_ = FALSE;
#line 321 "Color.c"
	}
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp13_ = _tmp1_;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (_tmp13_) {
#line 327 "Color.c"
		gdouble _tmp14_;
		PlankDrawingColor _tmp15_;
		gdouble _tmp16_;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp14_ = (*self).A;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp15_ = *color;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp16_ = _tmp15_.A;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp0_ = _tmp14_ == _tmp16_;
#line 339 "Color.c"
	} else {
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp0_ = FALSE;
#line 343 "Color.c"
	}
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp17_ = _tmp0_;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	result = _tmp17_;
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	return result;
#line 351 "Color.c"
}


/**
 * Set HSV color values of this color.
 */
void plank_drawing_color_set_hsv (PlankDrawingColor *self, gdouble h, gdouble s, gdouble v) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = h;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = s;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = v;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp3_;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp4_;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp5_;
#line 379 "Color.c"
}


/**
 * Sets the hue for the color.
 *
 * @param hue the new hue for the color
 */
void plank_drawing_color_set_hue (PlankDrawingColor *self, gdouble hue) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
#line 117 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = hue;
#line 117 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = hue;
#line 117 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 360)));
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).R;
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).G;
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp5_;
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp6_;
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp7_;
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = hue;
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp8_;
#line 123 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = h;
#line 123 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (_tmp9_, s, v, &_tmp10_, &_tmp11_, &_tmp12_);
#line 123 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp10_;
#line 123 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp11_;
#line 123 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp12_;
#line 439 "Color.c"
}


/**
 * Sets the saturation for the color.
 *
 * @param sat the new saturation for the color
 */
void plank_drawing_color_set_sat (PlankDrawingColor *self, gdouble sat) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = sat;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = sat;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).R;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).G;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp5_;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp6_;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp7_;
#line 136 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = sat;
#line 136 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp8_;
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = s;
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (h, _tmp9_, v, &_tmp10_, &_tmp11_, &_tmp12_);
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp10_;
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp11_;
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp12_;
#line 499 "Color.c"
}


/**
 * Sets the value for the color.
 *
 * @param val the new value for the color
 */
void plank_drawing_color_set_val (PlankDrawingColor *self, gdouble val) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
#line 145 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = val;
#line 145 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = val;
#line 145 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
#line 149 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).R;
#line 149 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).G;
#line 149 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 149 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 149 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp5_;
#line 149 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp6_;
#line 149 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp7_;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = val;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp8_;
#line 151 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = v;
#line 151 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (h, s, _tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
#line 151 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp10_;
#line 151 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp11_;
#line 151 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp12_;
#line 559 "Color.c"
}


/**
 * Sets the alpha for the color.
 *
 * @param alpha the new alpha for the color
 */
void plank_drawing_color_set_alpha (PlankDrawingColor *self, gdouble alpha) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = alpha;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = alpha;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
#line 162 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = alpha;
#line 162 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).A = _tmp2_;
#line 582 "Color.c"
}


/**
 * Get HSV color values of this color.
 */
void plank_drawing_color_get_hsv (PlankDrawingColor *self, gdouble* h, gdouble* s, gdouble* v) {
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 170 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = (*self).R;
#line 170 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = (*self).G;
#line 170 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).B;
#line 170 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 170 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_vala_h = _tmp3_;
#line 170 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_vala_s = _tmp4_;
#line 170 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_vala_v = _tmp5_;
#line 168 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (h) {
#line 168 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		*h = _vala_h;
#line 617 "Color.c"
	}
#line 168 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (s) {
#line 168 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		*s = _vala_s;
#line 623 "Color.c"
	}
#line 168 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (v) {
#line 168 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		*v = _vala_v;
#line 629 "Color.c"
	}
}


/**
 * Returns the hue for the color.
 *
 * @return the hue for the color
 */
gdouble plank_drawing_color_get_hue (PlankDrawingColor *self) {
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = (*self).R;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = (*self).G;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).B;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp3_;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp4_;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp5_;
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	result = h;
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	return result;
#line 668 "Color.c"
}


/**
 * Returns the saturation for the color.
 *
 * @return the saturation for the color
 */
gdouble plank_drawing_color_get_sat (PlankDrawingColor *self) {
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 193 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = (*self).R;
#line 193 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = (*self).G;
#line 193 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).B;
#line 193 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 193 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp3_;
#line 193 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp4_;
#line 193 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp5_;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	result = s;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	return result;
#line 706 "Color.c"
}


/**
 * Returns the value for the color.
 *
 * @return the value for the color
 */
gdouble plank_drawing_color_get_val (PlankDrawingColor *self) {
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 205 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = (*self).R;
#line 205 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = (*self).G;
#line 205 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).B;
#line 205 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 205 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp3_;
#line 205 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp4_;
#line 205 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp5_;
#line 206 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	result = v;
#line 206 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	return result;
#line 744 "Color.c"
}


/**
 * Increases the color's hue.
 *
 * @param val the amount to add to the hue
 */
void plank_drawing_color_add_hue (PlankDrawingColor *self, gdouble val) {
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
#line 217 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = (*self).R;
#line 217 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = (*self).G;
#line 217 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).B;
#line 217 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 217 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp3_;
#line 217 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp4_;
#line 217 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp5_;
#line 218 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp6_ = h;
#line 218 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp7_ = val;
#line 218 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = fmod (fmod (_tmp6_ + _tmp7_, 360) + 360, 360);
#line 219 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = h;
#line 219 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (_tmp8_, s, v, &_tmp9_, &_tmp10_, &_tmp11_);
#line 219 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp9_;
#line 219 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp10_;
#line 219 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp11_;
#line 799 "Color.c"
}


/**
 * Limits the color's saturation.
 *
 * @param sat the minimum saturation allowed
 */
void plank_drawing_color_set_min_sat (PlankDrawingColor *self, gdouble sat) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
#line 227 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = sat;
#line 227 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = sat;
#line 227 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).R;
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).G;
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp5_;
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp6_;
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp7_;
#line 232 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = s;
#line 232 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = sat;
#line 232 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp10_ = MAX (_tmp8_, _tmp9_);
#line 232 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp10_;
#line 233 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp11_ = s;
#line 233 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (h, _tmp11_, v, &_tmp12_, &_tmp13_, &_tmp14_);
#line 233 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp12_;
#line 233 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp13_;
#line 233 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp14_;
#line 865 "Color.c"
}


/**
 * Limits the color's value.
 *
 * @param val the minimum value allowed
 */
void plank_drawing_color_set_min_value (PlankDrawingColor *self, gdouble val) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
#line 241 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = val;
#line 241 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = val;
#line 241 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
#line 245 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).R;
#line 245 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).G;
#line 245 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 245 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 245 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp5_;
#line 245 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp6_;
#line 245 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp7_;
#line 246 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = v;
#line 246 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = val;
#line 246 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp10_ = MAX (_tmp8_, _tmp9_);
#line 246 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp10_;
#line 247 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp11_ = v;
#line 247 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (h, s, _tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
#line 247 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp12_;
#line 247 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp13_;
#line 247 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp14_;
#line 931 "Color.c"
}


/**
 * Limits the color's saturation.
 *
 * @param sat the maximum saturation allowed
 */
void plank_drawing_color_set_max_sat (PlankDrawingColor *self, gdouble sat) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
#line 255 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = sat;
#line 255 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = sat;
#line 255 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
#line 259 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).R;
#line 259 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).G;
#line 259 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 259 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 259 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp5_;
#line 259 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp6_;
#line 259 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp7_;
#line 260 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = s;
#line 260 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = sat;
#line 260 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp10_ = MIN (_tmp8_, _tmp9_);
#line 260 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp10_;
#line 261 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp11_ = s;
#line 261 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (h, _tmp11_, v, &_tmp12_, &_tmp13_, &_tmp14_);
#line 261 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp12_;
#line 261 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp13_;
#line 261 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp14_;
#line 997 "Color.c"
}


/**
 * Limits the color's value.
 *
 * @param val the maximum value allowed
 */
void plank_drawing_color_set_max_val (PlankDrawingColor *self, gdouble val) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
#line 269 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = val;
#line 269 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = val;
#line 269 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).R;
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).G;
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp5_;
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp6_;
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp7_;
#line 274 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = v;
#line 274 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = val;
#line 274 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp10_ = MIN (_tmp8_, _tmp9_);
#line 274 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp10_;
#line 275 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp11_ = v;
#line 275 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (h, s, _tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
#line 275 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp12_;
#line 275 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp13_;
#line 275 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp14_;
#line 1063 "Color.c"
}


/**
 * Multiplies the color's saturation using the amount.
 *
 * @param amount amount to multiply the saturation by
 */
void plank_drawing_color_multiply_sat (PlankDrawingColor *self, gdouble amount) {
	gdouble _tmp0_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
#line 283 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = amount;
#line 283 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail (_tmp0_ >= ((gdouble) 0));
#line 287 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = (*self).R;
#line 287 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).G;
#line 287 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).B;
#line 287 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp1_, _tmp2_, _tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 287 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp4_;
#line 287 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp5_;
#line 287 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp6_;
#line 288 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp7_ = s;
#line 288 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = amount;
#line 288 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = MIN ((gdouble) 1, _tmp7_ * _tmp8_);
#line 288 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp9_;
#line 289 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp10_ = s;
#line 289 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (h, _tmp10_, v, &_tmp11_, &_tmp12_, &_tmp13_);
#line 289 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp11_;
#line 289 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp12_;
#line 289 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp13_;
#line 1126 "Color.c"
}


/**
 * Brighten the color's value using the value.
 *
 * @param amount percent of the value to brighten by
 * @return the new color
 */
void plank_drawing_color_brighten_val (PlankDrawingColor *self, gdouble amount) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
#line 298 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = amount;
#line 298 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = amount;
#line 298 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
#line 302 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).R;
#line 302 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).G;
#line 302 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 302 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 302 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp5_;
#line 302 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp6_;
#line 302 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp7_;
#line 303 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = v;
#line 303 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = v;
#line 303 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp10_ = amount;
#line 303 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp11_ = MIN ((gdouble) 1, _tmp8_ + ((1 - _tmp9_) * _tmp10_));
#line 303 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp11_;
#line 304 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp12_ = v;
#line 304 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (h, s, _tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 304 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp13_;
#line 304 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp14_;
#line 304 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp15_;
#line 1196 "Color.c"
}


/**
 * Darkens the color's value using the value.
 *
 * @param amount percent of the value to darken by
 */
void plank_drawing_color_darken_val (PlankDrawingColor *self, gdouble amount) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = amount;
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = amount;
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
#line 316 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).R;
#line 316 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).G;
#line 316 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 316 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 316 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp5_;
#line 316 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp6_;
#line 316 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp7_;
#line 317 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = v;
#line 317 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = v;
#line 317 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp10_ = amount;
#line 317 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp11_ = MAX ((gdouble) 0, _tmp8_ - ((1 - _tmp9_) * _tmp10_));
#line 317 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp11_;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp12_ = v;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (h, s, _tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp13_;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp14_;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp15_;
#line 1265 "Color.c"
}


/**
 * Darkens the color's value using the saturtion.
 *
 * @param amount percent of the saturation to darken by
 */
void plank_drawing_color_darken_by_sat (PlankDrawingColor *self, gdouble amount) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
#line 326 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = amount;
#line 326 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = amount;
#line 326 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
#line 330 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).R;
#line 330 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = (*self).G;
#line 330 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 330 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_rgb_to_hsv (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 330 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	h = _tmp5_;
#line 330 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	s = _tmp6_;
#line 330 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp7_;
#line 331 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = v;
#line 331 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = amount;
#line 331 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp10_ = MAX ((gdouble) 0, _tmp8_ - (_tmp9_ * s));
#line 331 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	v = _tmp10_;
#line 332 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp11_ = v;
#line 332 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	plank_drawing_color_hsv_to_rgb (h, s, _tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
#line 332 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).R = _tmp12_;
#line 332 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).G = _tmp13_;
#line 332 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	(*self).B = _tmp14_;
#line 1331 "Color.c"
}


static void plank_drawing_color_rgb_to_hsv (gdouble r, gdouble g, gdouble b, gdouble* h, gdouble* s, gdouble* v) {
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	gdouble min;
	gdouble _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_ = 0.0;
	gdouble _tmp27_ = 0.0;
	gdouble max;
	gdouble _tmp28_;
	gdouble _tmp29_;
	gdouble delta;
	gdouble _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	gdouble _tmp33_;
	gdouble _tmp34_;
	gdouble _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	gdouble _tmp38_;
	gdouble _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_;
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = r;
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = r;
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 1)));
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = g;
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = g;
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp2_ >= ((gdouble) 0)) && (_tmp3_ <= ((gdouble) 1)));
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = b;
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp5_ = b;
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp4_ >= ((gdouble) 0)) && (_tmp5_ <= ((gdouble) 1)));
#line 340 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp6_ = r;
#line 340 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp7_ = g;
#line 340 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = b;
#line 340 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = MAX (_tmp7_, _tmp8_);
#line 340 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp10_ = MAX (_tmp6_, _tmp9_);
#line 340 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_vala_v = _tmp10_;
#line 341 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp11_ = _vala_v;
#line 341 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (_tmp11_ == ((gdouble) 0)) {
#line 342 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_vala_h = (gdouble) 0;
#line 343 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_vala_s = (gdouble) 0;
#line 344 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		if (h) {
#line 344 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			*h = _vala_h;
#line 1427 "Color.c"
		}
#line 344 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		if (s) {
#line 344 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			*s = _vala_s;
#line 1433 "Color.c"
		}
#line 344 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		if (v) {
#line 344 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			*v = _vala_v;
#line 1439 "Color.c"
		}
#line 344 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		return;
#line 1443 "Color.c"
	}
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp12_ = r;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp13_ = _vala_v;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	r = _tmp12_ / _tmp13_;
#line 349 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp14_ = g;
#line 349 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp15_ = _vala_v;
#line 349 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g = _tmp14_ / _tmp15_;
#line 350 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp16_ = b;
#line 350 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp17_ = _vala_v;
#line 350 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	b = _tmp16_ / _tmp17_;
#line 352 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp18_ = r;
#line 352 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp19_ = g;
#line 352 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp20_ = b;
#line 352 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp21_ = MIN (_tmp19_, _tmp20_);
#line 352 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp22_ = MIN (_tmp18_, _tmp21_);
#line 352 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	min = _tmp22_;
#line 353 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp23_ = r;
#line 353 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp24_ = g;
#line 353 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp25_ = b;
#line 353 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp26_ = MAX (_tmp24_, _tmp25_);
#line 353 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp27_ = MAX (_tmp23_, _tmp26_);
#line 353 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	max = _tmp27_;
#line 355 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp28_ = max;
#line 355 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp29_ = min;
#line 355 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	delta = _tmp28_ - _tmp29_;
#line 356 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp30_ = delta;
#line 356 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_vala_s = _tmp30_;
#line 357 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp31_ = _vala_s;
#line 357 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (_tmp31_ == ((gdouble) 0)) {
#line 358 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_vala_h = (gdouble) 0;
#line 359 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		if (h) {
#line 359 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			*h = _vala_h;
#line 1507 "Color.c"
		}
#line 359 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		if (s) {
#line 359 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			*s = _vala_s;
#line 1513 "Color.c"
		}
#line 359 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		if (v) {
#line 359 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			*v = _vala_v;
#line 1519 "Color.c"
		}
#line 359 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		return;
#line 1523 "Color.c"
	}
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp32_ = r;
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp33_ = min;
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp34_ = delta;
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	r = (_tmp32_ - _tmp33_) / _tmp34_;
#line 364 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp35_ = g;
#line 364 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp36_ = min;
#line 364 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp37_ = delta;
#line 364 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g = (_tmp35_ - _tmp36_) / _tmp37_;
#line 365 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp38_ = b;
#line 365 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp39_ = min;
#line 365 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp40_ = delta;
#line 365 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	b = (_tmp38_ - _tmp39_) / _tmp40_;
#line 367 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp41_ = max;
#line 367 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp42_ = r;
#line 367 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (_tmp41_ == _tmp42_) {
#line 1555 "Color.c"
		gdouble _tmp43_;
		gdouble _tmp44_;
		gdouble _tmp45_;
#line 368 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp43_ = g;
#line 368 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp44_ = b;
#line 368 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_vala_h = 0 + (60 * (_tmp43_ - _tmp44_));
#line 369 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp45_ = _vala_h;
#line 369 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		if (_tmp45_ < ((gdouble) 0)) {
#line 1569 "Color.c"
			gdouble _tmp46_;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			_tmp46_ = _vala_h;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			_vala_h = _tmp46_ + 360;
#line 1575 "Color.c"
		}
	} else {
		gdouble _tmp47_;
		gdouble _tmp48_;
#line 371 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp47_ = max;
#line 371 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp48_ = g;
#line 371 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		if (_tmp47_ == _tmp48_) {
#line 1586 "Color.c"
			gdouble _tmp49_;
			gdouble _tmp50_;
#line 372 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			_tmp49_ = b;
#line 372 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			_tmp50_ = r;
#line 372 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			_vala_h = 120 + (60 * (_tmp49_ - _tmp50_));
#line 1595 "Color.c"
		} else {
			gdouble _tmp51_;
			gdouble _tmp52_;
#line 374 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			_tmp51_ = r;
#line 374 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			_tmp52_ = g;
#line 374 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			_vala_h = 240 + (60 * (_tmp51_ - _tmp52_));
#line 1605 "Color.c"
		}
	}
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (h) {
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		*h = _vala_h;
#line 1612 "Color.c"
	}
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (s) {
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		*s = _vala_s;
#line 1618 "Color.c"
	}
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (v) {
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		*v = _vala_v;
#line 1624 "Color.c"
	}
}


static void plank_drawing_color_hsv_to_rgb (gdouble h, gdouble s, gdouble v, gdouble* r, gdouble* g, gdouble* b) {
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = h;
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = h;
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp0_ >= ((gdouble) 0)) && (_tmp1_ <= ((gdouble) 360)));
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = s;
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = s;
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp2_ >= ((gdouble) 0)) && (_tmp3_ <= ((gdouble) 1)));
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = v;
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp5_ = v;
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail ((_tmp4_ >= ((gdouble) 0)) && (_tmp5_ <= ((gdouble) 1)));
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_vala_r = (gdouble) 0;
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_vala_g = (gdouble) 0;
#line 385 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_vala_b = (gdouble) 0;
#line 387 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp6_ = s;
#line 387 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (_tmp6_ == ((gdouble) 0)) {
#line 1668 "Color.c"
		gdouble _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
#line 388 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp7_ = v;
#line 388 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_vala_r = _tmp7_;
#line 389 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp8_ = v;
#line 389 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_vala_g = _tmp8_;
#line 390 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp9_ = v;
#line 390 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_vala_b = _tmp9_;
#line 1684 "Color.c"
	} else {
		gdouble _tmp10_;
		gdouble _tmp11_ = 0.0;
		gint secNum;
		gdouble _tmp12_;
		gint _tmp13_;
		gdouble fracSec;
		gdouble _tmp14_;
		gdouble _tmp15_;
		gdouble p;
		gdouble _tmp16_;
		gdouble _tmp17_;
		gdouble _tmp18_;
		gdouble q;
		gdouble _tmp19_;
		gdouble _tmp20_;
		gdouble _tmp21_;
		gdouble t;
		gint _tmp22_;
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp10_ = h;
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp11_ = floor (_tmp10_ / 60);
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		secNum = (gint) _tmp11_;
#line 393 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp12_ = h;
#line 393 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp13_ = secNum;
#line 393 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		fracSec = (_tmp12_ / 60.0) - _tmp13_;
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp14_ = v;
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp15_ = s;
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		p = _tmp14_ * (1 - _tmp15_);
#line 396 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp16_ = v;
#line 396 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp17_ = s;
#line 396 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp18_ = fracSec;
#line 396 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		q = _tmp16_ * (1 - (_tmp17_ * _tmp18_));
#line 397 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp19_ = v;
#line 397 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp20_ = s;
#line 397 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp21_ = fracSec;
#line 397 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		t = _tmp19_ * (1 - (_tmp20_ * (1 - _tmp21_)));
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp22_ = secNum;
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		switch (_tmp22_) {
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			case 0:
#line 1744 "Color.c"
			{
				gdouble _tmp23_;
				gdouble _tmp24_;
				gdouble _tmp25_;
#line 401 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp23_ = v;
#line 401 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_r = _tmp23_;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp24_ = t;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_g = _tmp24_;
#line 403 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp25_ = p;
#line 403 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_b = _tmp25_;
#line 404 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				break;
#line 1763 "Color.c"
			}
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			case 1:
#line 1767 "Color.c"
			{
				gdouble _tmp26_;
				gdouble _tmp27_;
				gdouble _tmp28_;
#line 406 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp26_ = q;
#line 406 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_r = _tmp26_;
#line 407 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp27_ = v;
#line 407 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_g = _tmp27_;
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp28_ = p;
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_b = _tmp28_;
#line 409 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				break;
#line 1786 "Color.c"
			}
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			case 2:
#line 1790 "Color.c"
			{
				gdouble _tmp29_;
				gdouble _tmp30_;
				gdouble _tmp31_;
#line 411 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp29_ = p;
#line 411 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_r = _tmp29_;
#line 412 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp30_ = v;
#line 412 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_g = _tmp30_;
#line 413 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp31_ = t;
#line 413 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_b = _tmp31_;
#line 414 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				break;
#line 1809 "Color.c"
			}
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			case 3:
#line 1813 "Color.c"
			{
				gdouble _tmp32_;
				gdouble _tmp33_;
				gdouble _tmp34_;
#line 416 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp32_ = p;
#line 416 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_r = _tmp32_;
#line 417 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp33_ = q;
#line 417 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_g = _tmp33_;
#line 418 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp34_ = v;
#line 418 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_b = _tmp34_;
#line 419 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				break;
#line 1832 "Color.c"
			}
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			case 4:
#line 1836 "Color.c"
			{
				gdouble _tmp35_;
				gdouble _tmp36_;
				gdouble _tmp37_;
#line 421 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp35_ = t;
#line 421 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_r = _tmp35_;
#line 422 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp36_ = p;
#line 422 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_g = _tmp36_;
#line 423 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp37_ = v;
#line 423 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_b = _tmp37_;
#line 424 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				break;
#line 1855 "Color.c"
			}
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			case 5:
#line 1859 "Color.c"
			{
				gdouble _tmp38_;
				gdouble _tmp39_;
				gdouble _tmp40_;
#line 426 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp38_ = v;
#line 426 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_r = _tmp38_;
#line 427 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp39_ = p;
#line 427 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_g = _tmp39_;
#line 428 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_tmp40_ = q;
#line 428 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				_vala_b = _tmp40_;
#line 429 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
				break;
#line 1878 "Color.c"
			}
			default:
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
			break;
#line 1883 "Color.c"
		}
	}
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (r) {
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		*r = _vala_r;
#line 1890 "Color.c"
	}
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (g) {
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		*g = _vala_g;
#line 1896 "Color.c"
	}
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (b) {
#line 378 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		*b = _vala_b;
#line 1902 "Color.c"
	}
}


/**
 * Convert color to string formatted like "%d;;%d;;%d;;%d"
 * with numeric entries ranged in 0..255
 *
 * @return the string representation of this color
 */
gchar* plank_drawing_color_to_string (PlankDrawingColor *self) {
	gchar* result = NULL;
	gdouble _tmp0_;
	guint8 _tmp1_;
	gdouble _tmp2_;
	guint8 _tmp3_;
	gdouble _tmp4_;
	guint8 _tmp5_;
	gdouble _tmp6_;
	guint8 _tmp7_;
	gchar* _tmp8_ = NULL;
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = (*self).R;
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp1_ = G_MAXUINT8;
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = (*self).G;
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = G_MAXUINT8;
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp4_ = (*self).B;
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp5_ = G_MAXUINT8;
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp6_ = (*self).A;
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp7_ = G_MAXUINT8;
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = g_strdup_printf ("%d;;%d;;%d;;%d", (gint) (_tmp0_ * _tmp1_), (gint) (_tmp2_ * _tmp3_), (gint) (_tmp4_ * _tmp5_), (gint) (_tmp6_ * _tmp7_));
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	result = _tmp8_;
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	return result;
#line 1946 "Color.c"
}


/**
 * Create new color converted from string formatted like
 * "%d;;%d;;%d;;%d" with numeric entries ranged in 0..255
 *
 * @return new {@link Color} based on the given string
 */
void plank_drawing_color_from_string (const gchar* s, PlankDrawingColor* result) {
	const gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_ = NULL;
	gchar** parts;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	guint8 _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	const gchar* _tmp8_;
	gint _tmp9_ = 0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	guint8 _tmp12_;
	guint8 _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	const gchar* _tmp15_;
	gint _tmp16_ = 0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	guint8 _tmp19_;
	guint8 _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	const gchar* _tmp22_;
	gint _tmp23_ = 0;
	gdouble _tmp24_ = 0.0;
	gdouble _tmp25_ = 0.0;
	guint8 _tmp26_;
	guint8 _tmp27_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	const gchar* _tmp29_;
	gint _tmp30_ = 0;
	gdouble _tmp31_ = 0.0;
	gdouble _tmp32_ = 0.0;
	guint8 _tmp33_;
	PlankDrawingColor _tmp34_ = {0};
#line 454 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_return_if_fail (s != NULL);
#line 456 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp0_ = s;
#line 456 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ";;", 0);
#line 456 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	parts = _tmp2_;
#line 456 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	parts_length1 = _vala_array_length (_tmp1_);
#line 456 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_parts_size_ = parts_length1;
#line 458 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3_ = parts;
#line 458 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp3__length1 = parts_length1;
#line 458 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	if (_tmp3__length1 != 4) {
#line 2016 "Color.c"
		const gchar* _tmp4_;
		PlankDrawingColor _tmp5_ = {0};
#line 459 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp4_ = s;
#line 459 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		g_critical ("Color.vala:459: Malformed color string '%s'", _tmp4_);
#line 460 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		_tmp5_.R = (gdouble) 0;
#line 460 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		*result = _tmp5_;
#line 460 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 460 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
		return;
#line 2031 "Color.c"
	}
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp6_ = G_MAXUINT8;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp7_ = parts;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp7__length1 = parts_length1;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp8_ = _tmp7_[0];
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp9_ = atoi (_tmp8_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp10_ = MAX ((gdouble) 0, (gdouble) _tmp9_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp11_ = MIN ((gdouble) _tmp6_, _tmp10_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp12_ = G_MAXUINT8;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp13_ = G_MAXUINT8;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp14_ = parts;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp14__length1 = parts_length1;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp15_ = _tmp14_[1];
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp16_ = atoi (_tmp15_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp17_ = MAX ((gdouble) 0, (gdouble) _tmp16_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp18_ = MIN ((gdouble) _tmp13_, _tmp17_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp19_ = G_MAXUINT8;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp20_ = G_MAXUINT8;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp21_ = parts;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp21__length1 = parts_length1;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp22_ = _tmp21_[2];
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp23_ = atoi (_tmp22_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp24_ = MAX ((gdouble) 0, (gdouble) _tmp23_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp25_ = MIN ((gdouble) _tmp20_, _tmp24_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp26_ = G_MAXUINT8;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp27_ = G_MAXUINT8;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp28_ = parts;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp28__length1 = parts_length1;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp29_ = _tmp28_[3];
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp30_ = atoi (_tmp29_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp31_ = MAX ((gdouble) 0, (gdouble) _tmp30_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp32_ = MIN ((gdouble) _tmp27_, _tmp31_);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp33_ = G_MAXUINT8;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp34_.R = _tmp11_ / _tmp12_;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp34_.G = _tmp18_ / _tmp19_;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp34_.B = _tmp25_ / _tmp26_;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	_tmp34_.A = _tmp32_ / _tmp33_;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	*result = _tmp34_;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	return;
#line 2111 "Color.c"
}


PlankDrawingColor* plank_drawing_color_dup (const PlankDrawingColor* self) {
	PlankDrawingColor* dup;
#line 27 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	dup = g_new0 (PlankDrawingColor, 1);
#line 27 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	memcpy (dup, self, sizeof (PlankDrawingColor));
#line 27 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	return dup;
#line 2123 "Color.c"
}


void plank_drawing_color_free (PlankDrawingColor* self) {
#line 27 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/Color.vala"
	g_free (self);
#line 2130 "Color.c"
}


GType plank_drawing_color_get_type (void) {
	static volatile gsize plank_drawing_color_type_id__volatile = 0;
	if (g_once_init_enter (&plank_drawing_color_type_id__volatile)) {
		GType plank_drawing_color_type_id;
		plank_drawing_color_type_id = g_boxed_type_register_static ("PlankDrawingColor", (GBoxedCopyFunc) plank_drawing_color_dup, (GBoxedFreeFunc) plank_drawing_color_free);
		g_once_init_leave (&plank_drawing_color_type_id__volatile, plank_drawing_color_type_id);
	}
	return plank_drawing_color_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



