/* DrawingService.c generated by valac 0.18.1, the Vala compiler
 * generated from DrawingService.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <gtk/gtk.h>


#define PLANK_DRAWING_TYPE_DRAWING_SERVICE (plank_drawing_drawing_service_get_type ())
#define PLANK_DRAWING_DRAWING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingService))
#define PLANK_DRAWING_DRAWING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingServiceClass))
#define PLANK_DRAWING_IS_DRAWING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE))
#define PLANK_DRAWING_IS_DRAWING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_DRAWING_TYPE_DRAWING_SERVICE))
#define PLANK_DRAWING_DRAWING_SERVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingServiceClass))

typedef struct _PlankDrawingDrawingService PlankDrawingDrawingService;
typedef struct _PlankDrawingDrawingServiceClass PlankDrawingDrawingServiceClass;
typedef struct _PlankDrawingDrawingServicePrivate PlankDrawingDrawingServicePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define PLANK_DRAWING_TYPE_COLOR (plank_drawing_color_get_type ())
typedef struct _PlankDrawingColor PlankDrawingColor;

struct _PlankDrawingDrawingService {
	GObject parent_instance;
	PlankDrawingDrawingServicePrivate * priv;
};

struct _PlankDrawingDrawingServiceClass {
	GObjectClass parent_class;
};

struct _PlankDrawingColor {
	gdouble R;
	gdouble G;
	gdouble B;
	gdouble A;
};


static gpointer plank_drawing_drawing_service_parent_class = NULL;

GType plank_drawing_drawing_service_get_type (void) G_GNUC_CONST;
enum  {
	PLANK_DRAWING_DRAWING_SERVICE_DUMMY_PROPERTY
};
#define PLANK_DRAWING_DRAWING_SERVICE_MISSING_ICONS "application-default-icon;;application-x-executable"
#define PLANK_DRAWING_DRAWING_SERVICE_SATURATION_WEIGHT 1.5
#define PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD 1.0
#define PLANK_DRAWING_DRAWING_SERVICE_ALPHA_THRESHOLD ((guint8) 24)
static PlankDrawingDrawingService* plank_drawing_drawing_service_new (void);
static PlankDrawingDrawingService* plank_drawing_drawing_service_construct (GType object_type);
gchar* plank_drawing_drawing_service_get_icon_from_file (GFile* file);
gchar* plank_drawing_drawing_service_get_icon_from_gicon (GIcon* icon);
GdkPixbuf* plank_drawing_drawing_service_load_icon (const gchar* names, gint width, gint height);
static gboolean plank_drawing_drawing_service_icon_is_file (const gchar* name);
static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf_from_file (const gchar* name, gint width, gint height);
static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf (const gchar* icon, gint size);
GdkPixbuf* plank_drawing_drawing_service_ar_scale (GdkPixbuf* source, gint width, gint height);
static GdkPixbuf* plank_drawing_drawing_service_get_empty_pixbuf (gint width, gint height);
GFile* plank_services_paths_get_HomeFolder (void);
GType plank_drawing_color_get_type (void) G_GNUC_CONST;
PlankDrawingColor* plank_drawing_color_dup (const PlankDrawingColor* self);
void plank_drawing_color_free (PlankDrawingColor* self);
void plank_drawing_drawing_service_average_color (GdkPixbuf* source, PlankDrawingColor* result);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static PlankDrawingDrawingService* plank_drawing_drawing_service_construct (GType object_type) {
	PlankDrawingDrawingService * self = NULL;
#line 39 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	self = (PlankDrawingDrawingService*) g_object_new (object_type, NULL);
#line 39 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return self;
#line 105 "DrawingService.c"
}


static PlankDrawingDrawingService* plank_drawing_drawing_service_new (void) {
#line 39 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return plank_drawing_drawing_service_construct (PLANK_DRAWING_TYPE_DRAWING_SERVICE);
#line 112 "DrawingService.c"
}


/**
 * Gets the icon name from a {@link GLib.File}.
 *
 * @param file the file to get the icon name for
 * @return the icon name for the file, or null if none exists
 */
gchar* plank_drawing_drawing_service_get_icon_from_file (GFile* file) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 49 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 127 "DrawingService.c"
	{
		GFile* _tmp0_;
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* info;
		GFileInfo* _tmp2_;
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gchar* custom_icon;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
		gboolean _tmp8_;
		GFileInfo* _tmp17_;
		const gchar* _tmp18_ = NULL;
		gchar* _tmp19_;
		gchar* thumb_icon;
		gboolean _tmp20_ = FALSE;
		const gchar* _tmp21_;
		gboolean _tmp23_;
		GFileInfo* _tmp24_;
		GIcon* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
#line 52 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp0_ = file;
#line 52 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp1_ = g_file_query_info (_tmp0_, "*", 0, NULL, &_inner_error_);
#line 52 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		info = _tmp1_;
#line 52 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_inner_error_ != NULL) {
#line 157 "DrawingService.c"
			goto __catch1_g_error;
		}
#line 55 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp2_ = info;
#line 55 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp3_ = g_file_info_get_attribute_string (_tmp2_, "metadata::custom-icon");
#line 55 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 55 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		custom_icon = _tmp4_;
#line 56 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp6_ = custom_icon;
#line 56 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_tmp6_ != NULL) {
#line 172 "DrawingService.c"
			const gchar* _tmp7_;
#line 56 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp7_ = custom_icon;
#line 56 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
#line 178 "DrawingService.c"
		} else {
#line 56 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp5_ = FALSE;
#line 182 "DrawingService.c"
		}
#line 56 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp8_ = _tmp5_;
#line 56 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_tmp8_) {
#line 188 "DrawingService.c"
			const gchar* _tmp9_;
			gboolean _tmp10_ = FALSE;
			GFile* _tmp11_;
			const gchar* _tmp12_;
			GFile* _tmp13_ = NULL;
			GFile* _tmp14_;
			gchar* _tmp15_ = NULL;
			gchar* _tmp16_;
#line 57 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp9_ = custom_icon;
#line 57 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp10_ = g_str_has_prefix (_tmp9_, "file://");
#line 57 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			if (_tmp10_) {
#line 58 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				result = custom_icon;
#line 58 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_g_object_unref0 (info);
#line 58 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				return result;
#line 209 "DrawingService.c"
			}
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp11_ = file;
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp12_ = custom_icon;
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp13_ = g_file_get_child (_tmp11_, _tmp12_);
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp14_ = _tmp13_;
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp15_ = g_file_get_path (_tmp14_);
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp16_ = _tmp15_;
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_object_unref0 (_tmp14_);
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			result = _tmp16_;
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_free0 (custom_icon);
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_object_unref0 (info);
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			return result;
#line 233 "DrawingService.c"
		}
#line 63 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp17_ = info;
#line 63 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp18_ = g_file_info_get_attribute_string (_tmp17_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
#line 63 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 63 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		thumb_icon = _tmp19_;
#line 64 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp21_ = thumb_icon;
#line 64 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_tmp21_ != NULL) {
#line 247 "DrawingService.c"
			const gchar* _tmp22_;
#line 64 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp22_ = thumb_icon;
#line 64 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp20_ = g_strcmp0 (_tmp22_, "") != 0;
#line 253 "DrawingService.c"
		} else {
#line 64 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp20_ = FALSE;
#line 257 "DrawingService.c"
		}
#line 64 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp23_ = _tmp20_;
#line 64 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_tmp23_) {
#line 65 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			result = thumb_icon;
#line 65 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_free0 (custom_icon);
#line 65 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_object_unref0 (info);
#line 65 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			return result;
#line 271 "DrawingService.c"
		}
#line 68 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp24_ = info;
#line 68 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp25_ = g_file_info_get_icon (_tmp24_);
#line 68 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp26_ = plank_drawing_drawing_service_get_icon_from_gicon (_tmp25_);
#line 68 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		result = _tmp26_;
#line 68 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_free0 (thumb_icon);
#line 68 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_free0 (custom_icon);
#line 68 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_object_unref0 (info);
#line 68 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		return result;
#line 289 "DrawingService.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GFile* _tmp27_;
		gchar* _tmp28_ = NULL;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp32_;
#line 51 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error_);
#line 51 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_inner_error_ = NULL;
#line 70 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp27_ = file;
#line 70 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp28_ = g_file_get_path (_tmp27_);
#line 70 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp29_ = _tmp28_;
#line 70 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp30_ = _tmp29_;
#line 70 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_tmp30_ == NULL) {
#line 313 "DrawingService.c"
			gchar* _tmp31_;
#line 70 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp31_ = g_strdup ("");
#line 70 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_free0 (_tmp29_);
#line 70 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp29_ = _tmp31_;
#line 321 "DrawingService.c"
		}
#line 70 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp32_ = _tmp29_;
#line 70 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		g_debug ("DrawingService.vala:70: Could not get file info for '%s'", _tmp32_);
#line 51 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_free0 (_tmp29_);
#line 329 "DrawingService.c"
	}
	__finally1:
#line 51 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_inner_error_ != NULL) {
#line 51 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 51 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error_);
#line 51 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		return NULL;
#line 340 "DrawingService.c"
	}
#line 73 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	result = NULL;
#line 73 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return result;
#line 346 "DrawingService.c"
}


/**
 * Gets an icon from a {@link GLib.Icon}.
 *
 * @param icon the icon to get the name for
 * @return the icon name, or null if none exists
 */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1232 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1232 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1232 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 365 "DrawingService.c"
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* regex;
		GRegex* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 395 "DrawingService.c"
				goto __catch2_g_regex_error;
			}
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1234 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			return NULL;
#line 404 "DrawingService.c"
		}
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp5_ = regex;
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp6_ = replacement;
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_replace_literal (_tmp5_, self, (gssize) (-1), 0, _tmp6_, 0, &_inner_error_);
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 420 "DrawingService.c"
				goto __catch2_g_regex_error;
			}
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			return NULL;
#line 431 "DrawingService.c"
		}
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		result = _tmp8_;
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1235 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		return result;
#line 439 "DrawingService.c"
	}
	goto __finally2;
	__catch2_g_regex_error:
	{
		GError* e = NULL;
#line 1233 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1233 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1237 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1233 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 453 "DrawingService.c"
	}
	__finally2:
#line 1233 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	if (_inner_error_ != NULL) {
#line 1233 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1233 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1233 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		return NULL;
#line 464 "DrawingService.c"
	}
}


gchar* plank_drawing_drawing_service_get_icon_from_gicon (GIcon* icon) {
	gchar* result = NULL;
	GIcon* _tmp0_;
	GIcon* _tmp7_;
#line 84 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp0_ = icon;
#line 84 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_themed_icon_get_type ())) {
#line 477 "DrawingService.c"
		GIcon* _tmp1_;
		gchar** _tmp2_;
		gchar** _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* icons;
		const gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
#line 85 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp1_ = icon;
#line 85 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp3_ = _tmp2_ = g_themed_icon_get_names (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, g_themed_icon_get_type ()) ? ((GThemedIcon*) _tmp1_) : NULL);
#line 85 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp4_ = g_strjoinv (";;", _tmp3_);
#line 85 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		icons = _tmp4_;
#line 87 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp5_ = icons;
#line 87 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp6_ = string_replace (_tmp5_, "(null);;", "");
#line 87 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		result = _tmp6_;
#line 87 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_free0 (icons);
#line 87 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		return result;
#line 503 "DrawingService.c"
	}
#line 90 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp7_ = icon;
#line 90 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, g_file_icon_get_type ())) {
#line 509 "DrawingService.c"
		GIcon* _tmp8_;
		GFile* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp8_ = icon;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp9_ = g_file_icon_get_file (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, g_file_icon_get_type ()) ? ((GFileIcon*) _tmp8_) : NULL);
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		result = _tmp10_;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		return result;
#line 523 "DrawingService.c"
	}
#line 93 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	result = NULL;
#line 93 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return result;
#line 529 "DrawingService.c"
}


/**
 * Loads an icon based on names and the given width/height
 *
 * @param names a delimited (with ";;") list of icon names, first one found is used
 * @param width the requested width of the icon
 * @param height the requested height of the icon
 * @return the pixbuf representing the requested icon
 */
static gpointer _g_object_ref0 (gpointer self) {
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return self ? g_object_ref (self) : NULL;
#line 544 "DrawingService.c"
}


GdkPixbuf* plank_drawing_drawing_service_load_icon (const gchar* names, gint width, gint height) {
	GdkPixbuf* result = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* all_names;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_ = NULL;
	gchar** _tmp7_;
	gchar** _tmp8_ = NULL;
	GdkPixbuf* pbuf;
	GdkPixbuf* _tmp42_;
	gint _tmp63_;
	gint _tmp64_ = 0;
	gint _tmp65_;
	gint _tmp66_ = 0;
	GdkPixbuf* _tmp67_ = NULL;
#line 104 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (names != NULL, NULL);
#line 106 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 106 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	all_names = _tmp0_;
#line 108 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp1_ = names;
#line 108 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, ";;", 0);
#line 574 "DrawingService.c"
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
#line 108 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		s_collection = _tmp3_;
#line 108 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		s_collection_length1 = _vala_array_length (_tmp2_);
#line 108 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		for (s_it = 0; s_it < _vala_array_length (_tmp2_); s_it = s_it + 1) {
#line 586 "DrawingService.c"
			gchar* _tmp4_;
			gchar* s = NULL;
#line 108 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp4_ = g_strdup (s_collection[s_it]);
#line 108 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			s = _tmp4_;
#line 593 "DrawingService.c"
			{
				GeeArrayList* _tmp5_;
				const gchar* _tmp6_;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp5_ = all_names;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp6_ = s;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 108 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_g_free0 (s);
#line 605 "DrawingService.c"
			}
		}
#line 108 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		s_collection = (_vala_array_free (s_collection, s_collection_length1, (GDestroyNotify) g_free), NULL);
#line 610 "DrawingService.c"
	}
#line 110 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp8_ = _tmp7_ = g_strsplit (PLANK_DRAWING_DRAWING_SERVICE_MISSING_ICONS, ";;", 0);
#line 614 "DrawingService.c"
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
#line 110 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		s_collection = _tmp8_;
#line 110 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		s_collection_length1 = _vala_array_length (_tmp7_);
#line 110 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		for (s_it = 0; s_it < _vala_array_length (_tmp7_); s_it = s_it + 1) {
#line 626 "DrawingService.c"
			gchar* _tmp9_;
			gchar* s = NULL;
#line 110 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp9_ = g_strdup (s_collection[s_it]);
#line 110 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			s = _tmp9_;
#line 633 "DrawingService.c"
			{
				GeeArrayList* _tmp10_;
				const gchar* _tmp11_;
#line 111 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp10_ = all_names;
#line 111 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp11_ = s;
#line 111 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 110 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_g_free0 (s);
#line 645 "DrawingService.c"
			}
		}
#line 110 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		s_collection = (_vala_array_free (s_collection, s_collection_length1, (GDestroyNotify) g_free), NULL);
#line 650 "DrawingService.c"
	}
#line 113 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	pbuf = NULL;
#line 654 "DrawingService.c"
	{
		GeeArrayList* _tmp12_;
		GeeArrayList* _tmp13_;
		GeeArrayList* _name_list;
		GeeArrayList* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _name_size;
		gint _name_index;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp12_ = all_names;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_name_list = _tmp13_;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp14_ = _name_list;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp15_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp14_);
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp16_ = _tmp15_;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_name_size = _tmp16_;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_name_index = -1;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		while (TRUE) {
#line 682 "DrawingService.c"
			gint _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			GeeArrayList* _tmp20_;
			gint _tmp21_;
			gpointer _tmp22_ = NULL;
			gchar* name;
			const gchar* _tmp23_;
			gboolean _tmp24_ = FALSE;
			const gchar* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			gint _tmp33_ = 0;
			GdkPixbuf* _tmp34_ = NULL;
			GdkPixbuf* _tmp35_;
			const gchar* _tmp36_;
			GeeArrayList* _tmp37_;
			gpointer _tmp38_ = NULL;
			gchar* _tmp39_;
			gboolean _tmp40_;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp17_ = _name_index;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_name_index = _tmp17_ + 1;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp18_ = _name_index;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp19_ = _name_size;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			if (!(_tmp18_ < _tmp19_)) {
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				break;
#line 715 "DrawingService.c"
			}
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp20_ = _name_list;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp21_ = _name_index;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _tmp21_);
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			name = (gchar*) _tmp22_;
#line 116 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp23_ = name;
#line 116 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp24_ = plank_drawing_drawing_service_icon_is_file (_tmp23_);
#line 116 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			if (_tmp24_) {
#line 731 "DrawingService.c"
				const gchar* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				GdkPixbuf* _tmp28_ = NULL;
				GdkPixbuf* _tmp29_;
#line 117 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp25_ = name;
#line 117 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp26_ = width;
#line 117 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp27_ = height;
#line 117 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp28_ = plank_drawing_drawing_service_load_pixbuf_from_file (_tmp25_, _tmp26_, _tmp27_);
#line 117 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_g_object_unref0 (pbuf);
#line 117 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				pbuf = _tmp28_;
#line 118 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp29_ = pbuf;
#line 118 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				if (_tmp29_ != NULL) {
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_g_free0 (name);
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					break;
#line 757 "DrawingService.c"
				}
			}
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp30_ = name;
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp31_ = width;
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp32_ = height;
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp33_ = MAX (_tmp31_, _tmp32_);
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp34_ = plank_drawing_drawing_service_load_pixbuf (_tmp30_, _tmp33_);
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_object_unref0 (pbuf);
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			pbuf = _tmp34_;
#line 123 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp35_ = pbuf;
#line 123 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			if (_tmp35_ != NULL) {
#line 124 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_g_free0 (name);
#line 124 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				break;
#line 782 "DrawingService.c"
			}
#line 126 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp36_ = name;
#line 126 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp37_ = all_names;
#line 126 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp38_ = gee_abstract_list_last ((GeeAbstractList*) _tmp37_);
#line 126 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp39_ = (gchar*) _tmp38_;
#line 126 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp40_ = g_strcmp0 (_tmp36_, _tmp39_) != 0;
#line 126 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_free0 (_tmp39_);
#line 126 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			if (_tmp40_) {
#line 798 "DrawingService.c"
				const gchar* _tmp41_;
#line 127 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp41_ = name;
#line 127 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				g_message ("DrawingService.vala:127: Could not find icon '%s'", _tmp41_);
#line 804 "DrawingService.c"
			}
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_free0 (name);
#line 808 "DrawingService.c"
		}
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_object_unref0 (_name_list);
#line 812 "DrawingService.c"
	}
#line 130 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp42_ = pbuf;
#line 130 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_tmp42_ != NULL) {
#line 818 "DrawingService.c"
		gboolean _tmp43_ = FALSE;
		gboolean _tmp44_ = FALSE;
		gint _tmp45_;
		gboolean _tmp47_;
		gboolean _tmp58_;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp45_ = width;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_tmp45_ != (-1)) {
#line 828 "DrawingService.c"
			gint _tmp46_;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp46_ = height;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp44_ = _tmp46_ != (-1);
#line 834 "DrawingService.c"
		} else {
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp44_ = FALSE;
#line 838 "DrawingService.c"
		}
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp47_ = _tmp44_;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_tmp47_) {
#line 844 "DrawingService.c"
			gboolean _tmp48_ = FALSE;
			gint _tmp49_;
			GdkPixbuf* _tmp50_;
			gint _tmp51_;
			gint _tmp52_;
			gboolean _tmp57_;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp49_ = width;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp50_ = pbuf;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp51_ = gdk_pixbuf_get_width (_tmp50_);
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp52_ = _tmp51_;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			if (_tmp49_ != _tmp52_) {
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp48_ = TRUE;
#line 863 "DrawingService.c"
			} else {
				gint _tmp53_;
				GdkPixbuf* _tmp54_;
				gint _tmp55_;
				gint _tmp56_;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp53_ = height;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp54_ = pbuf;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp55_ = gdk_pixbuf_get_height (_tmp54_);
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp56_ = _tmp55_;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp48_ = _tmp53_ != _tmp56_;
#line 879 "DrawingService.c"
			}
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp57_ = _tmp48_;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp43_ = _tmp57_;
#line 885 "DrawingService.c"
		} else {
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp43_ = FALSE;
#line 889 "DrawingService.c"
		}
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp58_ = _tmp43_;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_tmp58_) {
#line 895 "DrawingService.c"
			GdkPixbuf* _tmp59_;
			gint _tmp60_;
			gint _tmp61_;
			GdkPixbuf* _tmp62_ = NULL;
#line 132 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp59_ = pbuf;
#line 132 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp60_ = width;
#line 132 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp61_ = height;
#line 132 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp62_ = plank_drawing_drawing_service_ar_scale (_tmp59_, _tmp60_, _tmp61_);
#line 132 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			result = _tmp62_;
#line 132 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_object_unref0 (pbuf);
#line 132 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_object_unref0 (all_names);
#line 132 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			return result;
#line 916 "DrawingService.c"
		}
#line 133 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		result = pbuf;
#line 133 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_object_unref0 (all_names);
#line 133 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		return result;
#line 924 "DrawingService.c"
	}
#line 136 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	g_warning ("DrawingService.vala:136: No icon found, return empty pixbuf");
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp63_ = width;
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp64_ = MAX (1, _tmp63_);
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp65_ = height;
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp66_ = MAX (1, _tmp65_);
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp67_ = plank_drawing_drawing_service_get_empty_pixbuf (_tmp64_, _tmp66_);
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	result = _tmp67_;
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_g_object_unref0 (pbuf);
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_g_object_unref0 (all_names);
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return result;
#line 946 "DrawingService.c"
}


static GdkPixbuf* plank_drawing_drawing_service_get_empty_pixbuf (gint width, gint height) {
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* pbuf;
#line 143 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp0_ = width;
#line 143 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp1_ = height;
#line 143 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp2_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, _tmp0_, _tmp1_);
#line 143 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	pbuf = _tmp2_;
#line 144 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	gdk_pixbuf_fill (pbuf, (guint32) 0x00000000);
#line 145 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	result = pbuf;
#line 145 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return result;
#line 970 "DrawingService.c"
}


static gboolean plank_drawing_drawing_service_icon_is_file (const gchar* name) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp6_;
	gboolean _tmp11_;
#line 148 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp2_ = name;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp3_ = g_str_has_prefix (_tmp2_, "/");
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_tmp3_) {
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp1_ = TRUE;
#line 992 "DrawingService.c"
	} else {
		const gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp4_ = name;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp5_ = g_str_has_prefix (_tmp4_, "~/");
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp1_ = _tmp5_;
#line 1002 "DrawingService.c"
	}
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp6_ = _tmp1_;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_tmp6_) {
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp0_ = TRUE;
#line 1010 "DrawingService.c"
	} else {
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		gboolean _tmp10_ = FALSE;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp7_ = name;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) (-1));
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp9_ = _tmp8_;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp10_ = g_str_has_prefix (_tmp9_, "file://");
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp0_ = _tmp10_;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_free0 (_tmp9_);
#line 1028 "DrawingService.c"
	}
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp11_ = _tmp0_;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	result = _tmp11_;
#line 150 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return result;
#line 1036 "DrawingService.c"
}


static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf_from_file (const gchar* name, gint width, gint height) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* filename;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GError * _inner_error_ = NULL;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 155 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	pbuf = NULL;
#line 157 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp0_ = name;
#line 157 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 157 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	filename = _tmp1_;
#line 158 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp2_ = name;
#line 158 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp3_ = g_str_has_prefix (_tmp2_, "~/");
#line 158 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_tmp3_) {
#line 1065 "DrawingService.c"
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp4_ = plank_services_paths_get_HomeFolder ();
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp5_ = _tmp4_;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp6_ = g_file_get_path (_tmp5_);
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp7_ = _tmp6_;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp8_ = _tmp7_;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_tmp8_ == NULL) {
#line 1086 "DrawingService.c"
			gchar* _tmp9_;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp9_ = g_strdup ("");
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_free0 (_tmp7_);
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp7_ = _tmp9_;
#line 1094 "DrawingService.c"
		}
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp10_ = name;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp11_ = _tmp7_;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp12_ = string_replace (_tmp10_, "~/", _tmp11_);
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_free0 (filename);
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		filename = _tmp12_;
#line 158 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_free0 (_tmp7_);
#line 1108 "DrawingService.c"
	}
	{
		const gchar* _tmp13_;
		gboolean _tmp14_ = FALSE;
#line 162 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp13_ = filename;
#line 162 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp14_ = g_str_has_prefix (_tmp13_, "file://");
#line 162 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_tmp14_) {
#line 1119 "DrawingService.c"
			const gchar* _tmp15_;
			GFile* _tmp16_ = NULL;
			GFile* _tmp17_;
			gchar* _tmp18_ = NULL;
			gchar* _tmp19_;
			GdkPixbuf* _tmp20_;
			GdkPixbuf* _tmp21_;
			GdkPixbuf* _tmp22_;
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp15_ = filename;
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp16_ = g_file_new_for_uri (_tmp15_);
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp17_ = _tmp16_;
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp18_ = g_file_get_path (_tmp17_);
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp19_ = _tmp18_;
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp20_ = gdk_pixbuf_new_from_file (_tmp19_, &_inner_error_);
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp21_ = _tmp20_;
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_free0 (_tmp19_);
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_object_unref0 (_tmp17_);
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp22_ = _tmp21_;
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			if (_inner_error_ != NULL) {
#line 1150 "DrawingService.c"
				goto __catch3_g_error;
			}
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_object_unref0 (pbuf);
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			pbuf = _tmp22_;
#line 1157 "DrawingService.c"
		} else {
			const gchar* _tmp23_;
			GFile* _tmp24_ = NULL;
			GFile* _tmp25_;
			gchar* _tmp26_ = NULL;
			gchar* _tmp27_;
			GdkPixbuf* _tmp28_;
			GdkPixbuf* _tmp29_;
			GdkPixbuf* _tmp30_;
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp23_ = filename;
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp24_ = g_file_new_for_path (_tmp23_);
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp25_ = _tmp24_;
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp26_ = g_file_get_path (_tmp25_);
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp27_ = _tmp26_;
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp28_ = gdk_pixbuf_new_from_file (_tmp27_, &_inner_error_);
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp29_ = _tmp28_;
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_free0 (_tmp27_);
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_object_unref0 (_tmp25_);
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp30_ = _tmp29_;
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			if (_inner_error_ != NULL) {
#line 1189 "DrawingService.c"
				goto __catch3_g_error;
			}
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_object_unref0 (pbuf);
#line 165 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			pbuf = _tmp30_;
#line 1196 "DrawingService.c"
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
#line 161 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error_);
#line 161 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_inner_error_ = NULL;
#line 1206 "DrawingService.c"
	}
	__finally3:
#line 161 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_inner_error_ != NULL) {
#line 161 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_free0 (filename);
#line 161 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 161 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 161 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error_);
#line 161 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		return NULL;
#line 1221 "DrawingService.c"
	}
#line 168 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	result = pbuf;
#line 168 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_g_free0 (filename);
#line 168 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return result;
#line 1229 "DrawingService.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
#line 1228 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1228 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1229 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1229 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1229 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1229 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	return result;
#line 1249 "DrawingService.c"
}


static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf (const gchar* icon, gint size) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf;
	GtkIconTheme* _tmp0_ = NULL;
	GtkIconTheme* icon_theme;
	GError * _inner_error_ = NULL;
#line 171 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 173 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	pbuf = NULL;
#line 174 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp0_ = gtk_icon_theme_get_default ();
#line 174 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	icon_theme = _tmp0_;
#line 1267 "DrawingService.c"
	{
		GtkIconTheme* _tmp1_;
		const gchar* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 177 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp1_ = icon_theme;
#line 177 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp2_ = icon;
#line 177 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp3_ = gtk_icon_theme_has_icon (_tmp1_, _tmp2_);
#line 177 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		if (_tmp3_) {
#line 1280 "DrawingService.c"
			GtkIconTheme* _tmp4_;
			const gchar* _tmp5_;
			gint _tmp6_;
			GdkPixbuf* _tmp7_ = NULL;
			GdkPixbuf* _tmp8_;
#line 178 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp4_ = icon_theme;
#line 178 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp5_ = icon;
#line 178 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp6_ = size;
#line 178 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp7_ = gtk_icon_theme_load_icon (_tmp4_, _tmp5_, _tmp6_, 0, &_inner_error_);
#line 178 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp8_ = _tmp7_;
#line 178 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			if (_inner_error_ != NULL) {
#line 1298 "DrawingService.c"
				goto __catch4_g_error;
			}
#line 178 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_g_object_unref0 (pbuf);
#line 178 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			pbuf = _tmp8_;
#line 1305 "DrawingService.c"
		} else {
			const gchar* _tmp9_;
			gboolean _tmp10_ = FALSE;
#line 179 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp9_ = icon;
#line 179 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp10_ = string_contains (_tmp9_, ".");
#line 179 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			if (_tmp10_) {
#line 1315 "DrawingService.c"
				const gchar* _tmp11_;
				gchar** _tmp12_;
				gchar** _tmp13_ = NULL;
				gchar** parts;
				gint parts_length1;
				gint _parts_size_;
				GtkIconTheme* _tmp14_;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				gboolean _tmp17_ = FALSE;
#line 180 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp11_ = icon;
#line 180 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, ".", 0);
#line 180 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				parts = _tmp13_;
#line 180 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				parts_length1 = _vala_array_length (_tmp12_);
#line 180 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_parts_size_ = parts_length1;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp14_ = icon_theme;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp15_ = parts;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp15__length1 = parts_length1;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp16_ = _tmp15_[0];
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp17_ = gtk_icon_theme_has_icon (_tmp14_, _tmp16_);
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				if (_tmp17_) {
#line 1349 "DrawingService.c"
					GtkIconTheme* _tmp18_;
					gchar** _tmp19_;
					gint _tmp19__length1;
					const gchar* _tmp20_;
					gint _tmp21_;
					GdkPixbuf* _tmp22_ = NULL;
					GdkPixbuf* _tmp23_;
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp18_ = icon_theme;
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp19_ = parts;
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp19__length1 = parts_length1;
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp20_ = _tmp19_[0];
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp21_ = size;
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp22_ = gtk_icon_theme_load_icon (_tmp18_, _tmp20_, _tmp21_, 0, &_inner_error_);
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp23_ = _tmp22_;
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					if (_inner_error_ != NULL) {
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1375 "DrawingService.c"
						goto __catch4_g_error;
					}
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_g_object_unref0 (pbuf);
#line 182 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					pbuf = _tmp23_;
#line 1382 "DrawingService.c"
				}
#line 179 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1386 "DrawingService.c"
			}
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
#line 176 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error_);
#line 176 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_inner_error_ = NULL;
#line 1397 "DrawingService.c"
	}
	__finally4:
#line 176 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_inner_error_ != NULL) {
#line 176 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 176 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 176 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error_);
#line 176 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		return NULL;
#line 1410 "DrawingService.c"
	}
#line 186 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	result = pbuf;
#line 186 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return result;
#line 1416 "DrawingService.c"
}


/**
 * Scales a {@link Gdk.Pixbuf}, maintaining the original aspect ratio.
 *
 * @param source the pixbuf to scale
 * @param width the width of the scaled pixbuf
 * @param height the height of the scaled pixbuf
 * @return the scaled pixbuf
 */
GdkPixbuf* plank_drawing_drawing_service_ar_scale (GdkPixbuf* source, gint width, gint height) {
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	GdkPixbuf* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble xScale;
	gint _tmp4_;
	GdkPixbuf* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gdouble yScale;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble scale;
	gdouble _tmp11_;
	GdkPixbuf* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gdouble _tmp17_;
	gint _tmp18_ = 0;
	gint scaled_width;
	GdkPixbuf* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gdouble _tmp22_;
	gint _tmp23_ = 0;
	gint scaled_height;
	GdkPixbuf* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	GdkPixbuf* _tmp27_ = NULL;
#line 197 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 199 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp0_ = width;
#line 199 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp1_ = source;
#line 199 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp2_ = gdk_pixbuf_get_width (_tmp1_);
#line 199 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp3_ = _tmp2_;
#line 199 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	xScale = ((gdouble) _tmp0_) / ((gdouble) _tmp3_);
#line 200 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp4_ = height;
#line 200 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp5_ = source;
#line 200 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp6_ = gdk_pixbuf_get_height (_tmp5_);
#line 200 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp7_ = _tmp6_;
#line 200 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	yScale = ((gdouble) _tmp4_) / ((gdouble) _tmp7_);
#line 201 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp8_ = xScale;
#line 201 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp9_ = yScale;
#line 201 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp10_ = MIN (_tmp8_, _tmp9_);
#line 201 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	scale = _tmp10_;
#line 203 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp11_ = scale;
#line 203 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_tmp11_ == ((gdouble) 1)) {
#line 1495 "DrawingService.c"
		GdkPixbuf* _tmp12_;
		GdkPixbuf* _tmp13_;
#line 204 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp12_ = source;
#line 204 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 204 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		result = _tmp13_;
#line 204 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		return result;
#line 1506 "DrawingService.c"
	}
#line 206 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp14_ = source;
#line 206 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp15_ = gdk_pixbuf_get_width (_tmp14_);
#line 206 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp16_ = _tmp15_;
#line 206 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp17_ = scale;
#line 206 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp18_ = MAX (1, (gint) (_tmp16_ * _tmp17_));
#line 206 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	scaled_width = _tmp18_;
#line 207 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp19_ = source;
#line 207 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp20_ = gdk_pixbuf_get_height (_tmp19_);
#line 207 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp21_ = _tmp20_;
#line 207 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp22_ = scale;
#line 207 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp23_ = MAX (1, (gint) (_tmp21_ * _tmp22_));
#line 207 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	scaled_height = _tmp23_;
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp24_ = source;
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp25_ = scaled_width;
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp26_ = scaled_height;
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp27_ = gdk_pixbuf_scale_simple (_tmp24_, _tmp25_, _tmp26_, GDK_INTERP_HYPER);
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	result = _tmp27_;
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return result;
#line 1544 "DrawingService.c"
}


/**
 * Computes and returns the average color of a {@link Gdk.Pixbuf}.
 * The resulting color is the average of all pixels which aren't
 * nearly transparent while saturated pixels are weighted more than
 * "grey" ones.
 *
 * @param source the pixbuf to use
 * @return the average color of the pixbuf
 */
void plank_drawing_drawing_service_average_color (GdkPixbuf* source, PlankDrawingColor* result) {
	guint8 r = 0U;
	guint8 g = 0U;
	guint8 b = 0U;
	guint8 a = 0U;
	guint8 min = 0U;
	guint8 max = 0U;
	gdouble delta = 0.0;
	gdouble rTotal;
	gdouble gTotal;
	gdouble bTotal;
	gdouble bTotal2;
	gdouble gTotal2;
	gdouble rTotal2;
	gdouble aTotal2;
	GdkPixbuf* _tmp0_;
	guint8* _tmp1_ = NULL;
	guint8* dataPtr;
	GdkPixbuf* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint n_channels;
	GdkPixbuf* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint width;
	GdkPixbuf* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint height;
	GdkPixbuf* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint rowstride;
	gint _tmp14_;
	gint _tmp15_;
	gint length;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint pixels;
	gdouble scoreTotal;
	gint _tmp77_;
	gdouble _tmp79_;
	gint _tmp80_;
	gdouble _tmp81_;
	gint _tmp82_;
	gdouble _tmp83_;
	gint _tmp84_;
	gdouble _tmp85_;
	gint _tmp86_;
	gdouble _tmp87_;
	gdouble _tmp94_;
	gint _tmp95_;
	guint8 _tmp96_;
	gdouble _tmp97_;
	gint _tmp98_;
	guint8 _tmp99_;
	gdouble _tmp100_;
	gint _tmp101_;
	guint8 _tmp102_;
	gdouble _tmp103_;
	gint _tmp104_;
	guint8 _tmp105_;
	gdouble _tmp106_;
	gdouble _tmp121_;
	gdouble _tmp122_;
	gdouble _tmp123_;
	gdouble _tmp124_ = 0.0;
	gdouble _tmp125_ = 0.0;
	gdouble max_val;
	gdouble _tmp126_;
	gdouble _tmp133_;
	gdouble _tmp134_;
	gdouble _tmp135_;
	gdouble _tmp136_;
	PlankDrawingColor _tmp137_ = {0};
#line 221 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	g_return_if_fail (source != NULL);
#line 226 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	rTotal = 0.0;
#line 227 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	gTotal = 0.0;
#line 228 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	bTotal = 0.0;
#line 230 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	bTotal2 = 0.0;
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	gTotal2 = 0.0;
#line 232 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	rTotal2 = 0.0;
#line 233 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	aTotal2 = 0.0;
#line 235 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp0_ = source;
#line 235 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp1_ = gdk_pixbuf_get_pixels (_tmp0_);
#line 235 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	dataPtr = _tmp1_;
#line 236 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp2_ = source;
#line 236 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp3_ = gdk_pixbuf_get_n_channels (_tmp2_);
#line 236 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp4_ = _tmp3_;
#line 236 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	n_channels = _tmp4_;
#line 237 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp5_ = source;
#line 237 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp6_ = gdk_pixbuf_get_width (_tmp5_);
#line 237 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp7_ = _tmp6_;
#line 237 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	width = _tmp7_;
#line 238 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp8_ = source;
#line 238 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp9_ = gdk_pixbuf_get_height (_tmp8_);
#line 238 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp10_ = _tmp9_;
#line 238 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	height = _tmp10_;
#line 239 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp11_ = source;
#line 239 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp12_ = gdk_pixbuf_get_rowstride (_tmp11_);
#line 239 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp13_ = _tmp12_;
#line 239 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	rowstride = _tmp13_;
#line 240 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp14_ = width;
#line 240 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp15_ = height;
#line 240 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	length = _tmp14_ * _tmp15_;
#line 241 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp16_ = height;
#line 241 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp17_ = rowstride;
#line 241 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp18_ = n_channels;
#line 241 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	pixels = (_tmp16_ * _tmp17_) / _tmp18_;
#line 242 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	scoreTotal = 0.0;
#line 1704 "DrawingService.c"
	{
		gint i;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		i = 0;
#line 1709 "DrawingService.c"
		{
			gboolean _tmp19_;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			_tmp19_ = TRUE;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
			while (TRUE) {
#line 1716 "DrawingService.c"
				gboolean _tmp20_;
				gint _tmp22_;
				gint _tmp23_;
				guint8* _tmp24_;
				guint8 _tmp25_;
				guint8* _tmp26_;
				guint8 _tmp27_;
				guint8* _tmp28_;
				guint8 _tmp29_;
				guint8* _tmp30_;
				guint8 _tmp31_;
				guint8 _tmp32_;
				guint8 _tmp36_;
				guint8 _tmp37_;
				guint8 _tmp38_;
				guint8 _tmp39_ = 0U;
				guint8 _tmp40_ = 0U;
				guint8 _tmp41_;
				guint8 _tmp42_;
				guint8 _tmp43_;
				guint8 _tmp44_ = 0U;
				guint8 _tmp45_ = 0U;
				guint8 _tmp46_;
				guint8 _tmp47_;
				gdouble _tmp48_ = 0.0;
				gdouble _tmp49_;
				gdouble _tmp52_;
				gdouble score;
				gdouble _tmp53_;
				gdouble _tmp54_;
				guint8 _tmp55_;
				guint8 _tmp56_;
				gdouble _tmp57_;
				gdouble _tmp58_;
				guint8 _tmp59_;
				guint8 _tmp60_;
				gdouble _tmp61_;
				gdouble _tmp62_;
				guint8 _tmp63_;
				guint8 _tmp64_;
				gdouble _tmp65_;
				gdouble _tmp66_;
				gdouble _tmp67_;
				guint8 _tmp68_;
				gdouble _tmp69_;
				guint8 _tmp70_;
				gdouble _tmp71_;
				guint8 _tmp72_;
				gdouble _tmp73_;
				guint8 _tmp74_;
				guint8* _tmp75_;
				gint _tmp76_;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp20_ = _tmp19_;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				if (!_tmp20_) {
#line 1773 "DrawingService.c"
					gint _tmp21_;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp21_ = i;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					i = _tmp21_ + 1;
#line 1779 "DrawingService.c"
				}
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp19_ = FALSE;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp22_ = i;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp23_ = pixels;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				if (!(_tmp22_ < _tmp23_)) {
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					break;
#line 1791 "DrawingService.c"
				}
#line 245 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp24_ = dataPtr;
#line 245 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp25_ = _tmp24_[0];
#line 245 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				r = _tmp25_;
#line 246 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp26_ = dataPtr;
#line 246 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp27_ = _tmp26_[1];
#line 246 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				g = _tmp27_;
#line 247 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp28_ = dataPtr;
#line 247 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp29_ = _tmp28_[2];
#line 247 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				b = _tmp29_;
#line 248 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp30_ = dataPtr;
#line 248 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp31_ = _tmp30_[3];
#line 248 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				a = _tmp31_;
#line 251 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp32_ = a;
#line 251 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				if (_tmp32_ <= PLANK_DRAWING_DRAWING_SERVICE_ALPHA_THRESHOLD) {
#line 1821 "DrawingService.c"
					gint _tmp33_;
					guint8* _tmp34_;
					gint _tmp35_;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp33_ = length;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					length = _tmp33_ - 1;
#line 253 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp34_ = dataPtr;
#line 253 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp35_ = n_channels;
#line 253 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					dataPtr = _tmp34_ + _tmp35_;
#line 254 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					continue;
#line 1837 "DrawingService.c"
				}
#line 257 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp36_ = r;
#line 257 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp37_ = g;
#line 257 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp38_ = b;
#line 257 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp39_ = MIN (_tmp37_, _tmp38_);
#line 257 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp40_ = MIN (_tmp36_, _tmp39_);
#line 257 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				min = _tmp40_;
#line 258 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp41_ = r;
#line 258 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp42_ = g;
#line 258 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp43_ = b;
#line 258 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp44_ = MAX (_tmp42_, _tmp43_);
#line 258 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp45_ = MAX (_tmp41_, _tmp44_);
#line 258 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				max = _tmp45_;
#line 259 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp46_ = max;
#line 259 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp47_ = min;
#line 259 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				delta = (gdouble) (_tmp46_ - _tmp47_);
#line 262 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp49_ = delta;
#line 262 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				if (_tmp49_ == ((gdouble) 0)) {
#line 262 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp48_ = 0.0;
#line 1875 "DrawingService.c"
				} else {
					gdouble _tmp50_;
					guint8 _tmp51_;
#line 262 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp50_ = delta;
#line 262 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp51_ = max;
#line 262 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
					_tmp48_ = _tmp50_ / _tmp51_;
#line 1885 "DrawingService.c"
				}
#line 262 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp52_ = _tmp48_;
#line 262 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				score = PLANK_DRAWING_DRAWING_SERVICE_SATURATION_WEIGHT * _tmp52_;
#line 265 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp53_ = bTotal;
#line 265 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp54_ = score;
#line 265 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp55_ = b;
#line 265 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp56_ = a;
#line 265 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				bTotal = _tmp53_ + ((_tmp54_ * _tmp55_) / _tmp56_);
#line 266 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp57_ = gTotal;
#line 266 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp58_ = score;
#line 266 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp59_ = g;
#line 266 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp60_ = a;
#line 266 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				gTotal = _tmp57_ + ((_tmp58_ * _tmp59_) / _tmp60_);
#line 267 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp61_ = rTotal;
#line 267 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp62_ = score;
#line 267 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp63_ = r;
#line 267 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp64_ = a;
#line 267 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				rTotal = _tmp61_ + ((_tmp62_ * _tmp63_) / _tmp64_);
#line 268 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp65_ = scoreTotal;
#line 268 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp66_ = score;
#line 268 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				scoreTotal = _tmp65_ + _tmp66_;
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp67_ = bTotal2;
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp68_ = b;
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				bTotal2 = _tmp67_ + _tmp68_;
#line 272 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp69_ = gTotal2;
#line 272 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp70_ = g;
#line 272 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				gTotal2 = _tmp69_ + _tmp70_;
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp71_ = rTotal2;
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp72_ = r;
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				rTotal2 = _tmp71_ + _tmp72_;
#line 274 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp73_ = aTotal2;
#line 274 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp74_ = a;
#line 274 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				aTotal2 = _tmp73_ + _tmp74_;
#line 276 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp75_ = dataPtr;
#line 276 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				_tmp76_ = n_channels;
#line 276 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
				dataPtr = _tmp75_ + _tmp76_;
#line 1957 "DrawingService.c"
			}
		}
	}
#line 280 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp77_ = length;
#line 280 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_tmp77_ <= 0) {
#line 1965 "DrawingService.c"
		PlankDrawingColor _tmp78_ = {0};
#line 281 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp78_.R = 0.0;
#line 281 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp78_.G = 0.0;
#line 281 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp78_.B = 0.0;
#line 281 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp78_.A = 0.0;
#line 281 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		*result = _tmp78_;
#line 281 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		return;
#line 1979 "DrawingService.c"
	}
#line 283 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp79_ = scoreTotal;
#line 283 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp80_ = length;
#line 283 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	scoreTotal = _tmp79_ / _tmp80_;
#line 284 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp81_ = bTotal;
#line 284 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp82_ = length;
#line 284 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	bTotal = _tmp81_ / _tmp82_;
#line 285 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp83_ = gTotal;
#line 285 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp84_ = length;
#line 285 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	gTotal = _tmp83_ / _tmp84_;
#line 286 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp85_ = rTotal;
#line 286 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp86_ = length;
#line 286 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	rTotal = _tmp85_ / _tmp86_;
#line 288 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp87_ = scoreTotal;
#line 288 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_tmp87_ > 0.0) {
#line 2009 "DrawingService.c"
		gdouble _tmp88_;
		gdouble _tmp89_;
		gdouble _tmp90_;
		gdouble _tmp91_;
		gdouble _tmp92_;
		gdouble _tmp93_;
#line 289 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp88_ = bTotal;
#line 289 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp89_ = scoreTotal;
#line 289 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		bTotal = _tmp88_ / _tmp89_;
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp90_ = gTotal;
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp91_ = scoreTotal;
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		gTotal = _tmp90_ / _tmp91_;
#line 291 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp92_ = rTotal;
#line 291 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp93_ = scoreTotal;
#line 291 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		rTotal = _tmp92_ / _tmp93_;
#line 2034 "DrawingService.c"
	}
#line 294 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp94_ = bTotal2;
#line 294 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp95_ = length;
#line 294 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp96_ = G_MAXUINT8;
#line 294 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	bTotal2 = _tmp94_ / (_tmp95_ * _tmp96_);
#line 295 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp97_ = gTotal2;
#line 295 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp98_ = length;
#line 295 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp99_ = G_MAXUINT8;
#line 295 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	gTotal2 = _tmp97_ / (_tmp98_ * _tmp99_);
#line 296 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp100_ = rTotal2;
#line 296 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp101_ = length;
#line 296 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp102_ = G_MAXUINT8;
#line 296 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	rTotal2 = _tmp100_ / (_tmp101_ * _tmp102_);
#line 297 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp103_ = aTotal2;
#line 297 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp104_ = length;
#line 297 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp105_ = G_MAXUINT8;
#line 297 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	aTotal2 = _tmp103_ / (_tmp104_ * _tmp105_);
#line 302 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp106_ = scoreTotal;
#line 302 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_tmp106_ <= PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD) {
#line 2072 "DrawingService.c"
		gdouble _tmp107_;
		gdouble f;
		gdouble _tmp108_;
		gdouble rf;
		gdouble _tmp109_;
		gdouble _tmp110_;
		gdouble _tmp111_;
		gdouble _tmp112_;
		gdouble _tmp113_;
		gdouble _tmp114_;
		gdouble _tmp115_;
		gdouble _tmp116_;
		gdouble _tmp117_;
		gdouble _tmp118_;
		gdouble _tmp119_;
		gdouble _tmp120_;
#line 303 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp107_ = scoreTotal;
#line 303 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		f = (1.0 / PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD) * _tmp107_;
#line 304 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp108_ = f;
#line 304 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		rf = 1.0 - _tmp108_;
#line 305 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp109_ = bTotal;
#line 305 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp110_ = f;
#line 305 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp111_ = bTotal2;
#line 305 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp112_ = rf;
#line 305 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		bTotal = (_tmp109_ * _tmp110_) + (_tmp111_ * _tmp112_);
#line 306 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp113_ = gTotal;
#line 306 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp114_ = f;
#line 306 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp115_ = gTotal2;
#line 306 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp116_ = rf;
#line 306 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		gTotal = (_tmp113_ * _tmp114_) + (_tmp115_ * _tmp116_);
#line 307 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp117_ = rTotal;
#line 307 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp118_ = f;
#line 307 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp119_ = rTotal2;
#line 307 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp120_ = rf;
#line 307 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		rTotal = (_tmp117_ * _tmp118_) + (_tmp119_ * _tmp120_);
#line 2127 "DrawingService.c"
	}
#line 311 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp121_ = rTotal;
#line 311 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp122_ = gTotal;
#line 311 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp123_ = bTotal;
#line 311 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp124_ = MAX (_tmp122_, _tmp123_);
#line 311 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp125_ = MAX (_tmp121_, _tmp124_);
#line 311 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	max_val = _tmp125_;
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp126_ = max_val;
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	if (_tmp126_ > 1.0) {
#line 2145 "DrawingService.c"
		gdouble _tmp127_;
		gdouble _tmp128_;
		gdouble _tmp129_;
		gdouble _tmp130_;
		gdouble _tmp131_;
		gdouble _tmp132_;
#line 313 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp127_ = bTotal;
#line 313 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp128_ = max_val;
#line 313 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		bTotal = _tmp127_ / _tmp128_;
#line 314 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp129_ = gTotal;
#line 314 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp130_ = max_val;
#line 314 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		gTotal = _tmp129_ / _tmp130_;
#line 315 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp131_ = rTotal;
#line 315 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		_tmp132_ = max_val;
#line 315 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
		rTotal = _tmp131_ / _tmp132_;
#line 2170 "DrawingService.c"
	}
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp133_ = rTotal;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp134_ = gTotal;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp135_ = bTotal;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp136_ = aTotal2;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp137_.R = _tmp133_;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp137_.G = _tmp134_;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp137_.B = _tmp135_;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	_tmp137_.A = _tmp136_;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	*result = _tmp137_;
#line 318 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	return;
#line 2192 "DrawingService.c"
}


static void plank_drawing_drawing_service_class_init (PlankDrawingDrawingServiceClass * klass) {
#line 30 "/builddir/build/BUILD/plank-0.2.0.834/lib/Drawing/DrawingService.vala"
	plank_drawing_drawing_service_parent_class = g_type_class_peek_parent (klass);
#line 2199 "DrawingService.c"
}


static void plank_drawing_drawing_service_instance_init (PlankDrawingDrawingService * self) {
}


/**
 * Utility service for loading icons and working with pixbufs.
 */
GType plank_drawing_drawing_service_get_type (void) {
	static volatile gsize plank_drawing_drawing_service_type_id__volatile = 0;
	if (g_once_init_enter (&plank_drawing_drawing_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankDrawingDrawingServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_drawing_drawing_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDrawingDrawingService), 0, (GInstanceInitFunc) plank_drawing_drawing_service_instance_init, NULL };
		GType plank_drawing_drawing_service_type_id;
		plank_drawing_drawing_service_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDrawingDrawingService", &g_define_type_info, 0);
		g_once_init_leave (&plank_drawing_drawing_service_type_id__volatile, plank_drawing_drawing_service_type_id);
	}
	return plank_drawing_drawing_service_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



