/* WindowControl.c generated by valac 0.18.1, the Vala compiler
 * generated from WindowControl.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <libwnck/libwnck.h>
#include <libbamf/libbamf.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <gtk/gtk.h>
#include <string.h>


#define PLANK_SERVICES_WINDOWS_TYPE_STRUTS (plank_services_windows_struts_get_type ())

#define PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL (plank_services_windows_window_control_get_type ())
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControl))
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControlClass))
#define PLANK_SERVICES_WINDOWS_IS_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL))
#define PLANK_SERVICES_WINDOWS_IS_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL))
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL, PlankServicesWindowsWindowControlClass))

typedef struct _PlankServicesWindowsWindowControl PlankServicesWindowsWindowControl;
typedef struct _PlankServicesWindowsWindowControlClass PlankServicesWindowsWindowControlClass;
typedef struct _PlankServicesWindowsWindowControlPrivate PlankServicesWindowsWindowControlPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
typedef struct _Block1Data Block1Data;

typedef enum  {
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM,
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START,
	PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START,
	PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP_START,
	PLANK_SERVICES_WINDOWS_STRUTS_TOP_END,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START,
	PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END,
	PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES
} PlankServicesWindowsStruts;

struct _PlankServicesWindowsWindowControl {
	GObject parent_instance;
	PlankServicesWindowsWindowControlPrivate * priv;
};

struct _PlankServicesWindowsWindowControlClass {
	GObjectClass parent_class;
};

struct _Block1Data {
	int _ref_count_;
	guint32 time;
	WnckWindow* targetWindow;
};


static gpointer plank_services_windows_window_control_parent_class = NULL;

GType plank_services_windows_struts_get_type (void) G_GNUC_CONST;
GType plank_services_windows_window_control_get_type (void) G_GNUC_CONST;
enum  {
	PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_DUMMY_PROPERTY
};
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY ((guint) 10000)
#define PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY ((guint) 200)
static PlankServicesWindowsWindowControl* plank_services_windows_window_control_new (void);
static PlankServicesWindowsWindowControl* plank_services_windows_window_control_construct (GType object_type);
void plank_services_windows_window_control_initialize (void);
static void plank_services_windows_window_control_window_manager_changed (WnckScreen* screen);
static void _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender, gpointer self);
GdkPixbuf* plank_services_windows_window_control_get_app_icon (BamfApplication* app);
GdkPixbuf* plank_services_windows_window_control_get_window_icon (BamfWindow* window);
guint plank_services_windows_window_control_get_num_windows (BamfApplication* app);
gboolean plank_services_windows_window_control_has_maximized_window (BamfApplication* app);
gboolean plank_services_windows_window_control_has_minimized_window (BamfApplication* app);
gboolean plank_services_windows_window_control_has_window_on_workspace (BamfApplication* app, WnckWorkspace* workspace);
GeeArrayList* plank_services_windows_window_control_get_windows (BamfApplication* app);
void plank_services_windows_window_control_update_icon_regions (BamfApplication* app, GdkRectangle* rect);
void plank_services_windows_window_control_close_all (BamfApplication* app);
void plank_services_windows_window_control_focus_window (BamfWindow* window);
static void plank_services_windows_window_control_center_and_focus_window (WnckWindow* w);
void plank_services_windows_window_control_focus_window_by_xid (guint32 xid);
void plank_services_windows_window_control_focus (BamfApplication* app);
GeeArrayList* plank_services_windows_window_control_get_ordered_window_stack (BamfApplication* app);
static gint plank_services_windows_window_control_find_active_xid_index (GArray* xids);
void plank_services_windows_window_control_focus_previous (BamfApplication* app);
void plank_services_windows_window_control_focus_next (BamfApplication* app);
void plank_services_windows_window_control_minimize (BamfApplication* app);
void plank_services_windows_window_control_restore (BamfApplication* app);
void plank_services_windows_window_control_maximize (BamfApplication* app);
void plank_services_windows_window_control_unmaximize (BamfApplication* app);
void plank_services_windows_window_control_smart_focus (BamfApplication* app);
static void plank_services_windows_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow, GeeArrayList* additional_windows);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean plank_services_windows_window_control_windows_share_viewport (WnckWindow* first, WnckWindow* second);
static gboolean __lambda2_ (Block1Data* _data1_);
static gboolean ___lambda2__gsource_func (gpointer self);
void plank_services_windows_window_control_get_easy_geometry (WnckWindow* w, GdkRectangle* result);


GType plank_services_windows_struts_get_type (void) {
	static volatile gsize plank_services_windows_struts_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_windows_struts_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_SERVICES_WINDOWS_STRUTS_LEFT, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT", "left"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT", "right"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP, "PLANK_SERVICES_WINDOWS_STRUTS_TOP", "top"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM", "bottom"}, {PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT_START", "left-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END, "PLANK_SERVICES_WINDOWS_STRUTS_LEFT_END", "left-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_START", "right-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END, "PLANK_SERVICES_WINDOWS_STRUTS_RIGHT_END", "right-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP_START, "PLANK_SERVICES_WINDOWS_STRUTS_TOP_START", "top-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_TOP_END, "PLANK_SERVICES_WINDOWS_STRUTS_TOP_END", "top-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_START", "bottom-start"}, {PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END, "PLANK_SERVICES_WINDOWS_STRUTS_BOTTOM_END", "bottom-end"}, {PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES, "PLANK_SERVICES_WINDOWS_STRUTS_N_VALUES", "n-values"}, {0, NULL, NULL}};
		GType plank_services_windows_struts_type_id;
		plank_services_windows_struts_type_id = g_enum_register_static ("PlankServicesWindowsStruts", values);
		g_once_init_leave (&plank_services_windows_struts_type_id__volatile, plank_services_windows_struts_type_id);
	}
	return plank_services_windows_struts_type_id__volatile;
}


static PlankServicesWindowsWindowControl* plank_services_windows_window_control_construct (GType object_type) {
	PlankServicesWindowsWindowControl * self = NULL;
#line 48 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	self = (PlankServicesWindowsWindowControl*) g_object_new (object_type, NULL);
#line 48 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return self;
#line 146 "WindowControl.c"
}


static PlankServicesWindowsWindowControl* plank_services_windows_window_control_new (void) {
#line 48 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return plank_services_windows_window_control_construct (PLANK_SERVICES_WINDOWS_TYPE_WINDOW_CONTROL);
#line 153 "WindowControl.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return self ? g_object_ref (self) : NULL;
#line 160 "WindowControl.c"
}


static void _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender, gpointer self) {
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	plank_services_windows_window_control_window_manager_changed (_sender);
#line 167 "WindowControl.c"
}


void plank_services_windows_window_control_initialize (void) {
	WnckScreen* _tmp0_ = NULL;
	WnckScreen* _tmp1_;
	WnckScreen* screen;
	const gchar* _tmp2_ = NULL;
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = wnck_screen_get_default ();
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 54 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	screen = _tmp1_;
#line 56 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_set_client_type (WNCK_CLIENT_TYPE_PAGER);
#line 58 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_force_update (screen);
#line 59 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_signal_connect (screen, "window-manager-changed", (GCallback) _plank_services_windows_window_control_window_manager_changed_wnck_screen_window_manager_changed, NULL);
#line 61 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = wnck_screen_get_window_manager_name (screen);
#line 61 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_message ("WindowControl.vala:61: Window-manager: %s", _tmp2_);
#line 52 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_object_unref0 (screen);
#line 194 "WindowControl.c"
}


static void plank_services_windows_window_control_window_manager_changed (WnckScreen* screen) {
	WnckScreen* _tmp0_;
	const gchar* _tmp1_ = NULL;
#line 64 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (screen != NULL);
#line 66 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = screen;
#line 66 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = wnck_screen_get_window_manager_name (_tmp0_);
#line 66 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warning ("WindowControl.vala:66: Window-manager changed: %s", _tmp1_);
#line 209 "WindowControl.c"
}


GdkPixbuf* plank_services_windows_window_control_get_app_icon (BamfApplication* app) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf;
	BamfApplication* _tmp0_;
	GArray* _tmp1_ = NULL;
	GArray* xids;
	GArray* _tmp2_;
	GdkPixbuf* _tmp23_;
#line 69 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 71 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	pbuf = NULL;
#line 73 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 74 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = app;
#line 74 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = bamf_application_get_xids (_tmp0_);
#line 74 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	xids = _tmp1_;
#line 76 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 76 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp2_ != NULL);
#line 237 "WindowControl.c"
	{
		gint i;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		i = 0;
#line 242 "WindowControl.c"
		{
			gboolean _tmp3_;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp3_ = TRUE;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			while (TRUE) {
#line 249 "WindowControl.c"
				gboolean _tmp4_;
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				GArray* _tmp8_;
				gboolean _tmp12_;
				gboolean _tmp14_;
				GArray* _tmp15_;
				gint _tmp16_;
				guint32 _tmp17_ = 0U;
				WnckWindow* _tmp18_ = NULL;
				WnckWindow* _tmp19_;
				WnckWindow* window;
				WnckWindow* _tmp20_;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp4_ = _tmp3_;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp4_) {
#line 267 "WindowControl.c"
					gint _tmp5_;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp5_ = i;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					i = _tmp5_ + 1;
#line 273 "WindowControl.c"
				}
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp3_ = FALSE;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp8_ = xids;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp8_ != NULL) {
#line 281 "WindowControl.c"
					gint _tmp9_;
					GArray* _tmp10_;
					guint _tmp11_;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp9_ = i;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp10_ = xids;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp11_ = _tmp10_->len;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp7_ = ((guint) _tmp9_) < _tmp11_;
#line 293 "WindowControl.c"
				} else {
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp7_ = FALSE;
#line 297 "WindowControl.c"
				}
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp12_ = _tmp7_;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp12_) {
#line 303 "WindowControl.c"
					GdkPixbuf* _tmp13_;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp13_ = pbuf;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp6_ = _tmp13_ == NULL;
#line 309 "WindowControl.c"
				} else {
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp6_ = FALSE;
#line 313 "WindowControl.c"
				}
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp14_ = _tmp6_;
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp14_) {
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					break;
#line 321 "WindowControl.c"
				}
#line 79 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp15_ = xids;
#line 79 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp16_ = i;
#line 79 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp17_ = g_array_index (_tmp15_, guint32, (guint) _tmp16_);
#line 79 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp18_ = wnck_window_get ((gulong) _tmp17_);
#line 79 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp19_ = _g_object_ref0 (_tmp18_);
#line 79 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				window = _tmp19_;
#line 80 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp20_ = window;
#line 80 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp20_ != NULL) {
#line 339 "WindowControl.c"
					WnckWindow* _tmp21_;
					GdkPixbuf* _tmp22_ = NULL;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp21_ = window;
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp22_ = wnck_window_get_icon (_tmp21_);
#line 81 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					pbuf = _tmp22_;
#line 348 "WindowControl.c"
				}
#line 78 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 352 "WindowControl.c"
			}
		}
	}
#line 84 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp23_ = pbuf;
#line 84 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	result = _tmp23_;
#line 84 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 84 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 364 "WindowControl.c"
}


GdkPixbuf* plank_services_windows_window_control_get_window_icon (BamfWindow* window) {
	GdkPixbuf* result = NULL;
	BamfWindow* _tmp0_;
	guint32 _tmp1_ = 0U;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_;
	WnckWindow* w;
	WnckWindow* _tmp4_;
	WnckWindow* _tmp5_;
	WnckWindow* _tmp6_;
	GdkPixbuf* _tmp7_ = NULL;
#line 87 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 89 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = window;
#line 89 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = bamf_window_get_xid (_tmp0_);
#line 89 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = wnck_window_get ((gulong) _tmp1_);
#line 89 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 89 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	w = _tmp3_;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp4_ = w;
#line 91 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp4_ != NULL);
#line 93 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp5_ = w;
#line 93 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp5_ == NULL) {
#line 94 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		result = NULL;
#line 94 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (w);
#line 94 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		return result;
#line 405 "WindowControl.c"
	}
#line 96 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp6_ = w;
#line 96 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp7_ = wnck_window_get_icon (_tmp6_);
#line 96 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	result = _tmp7_;
#line 96 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_object_unref0 (w);
#line 96 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 417 "WindowControl.c"
}


guint plank_services_windows_window_control_get_num_windows (BamfApplication* app) {
	guint result = 0U;
	BamfApplication* _tmp0_;
	GArray* _tmp1_ = NULL;
	GArray* xids;
	GArray* _tmp2_;
	GArray* _tmp3_;
	GArray* _tmp4_;
	guint _tmp5_;
#line 99 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, 0U);
#line 101 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 102 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = app;
#line 102 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = bamf_application_get_xids (_tmp0_);
#line 102 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	xids = _tmp1_;
#line 104 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 104 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp2_ != NULL);
#line 106 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = xids;
#line 106 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp3_ == NULL) {
#line 107 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		result = (guint) 0;
#line 107 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_array_unref0 (xids);
#line 107 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		return result;
#line 454 "WindowControl.c"
	}
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp4_ = xids;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp5_ = _tmp4_->len;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	result = _tmp5_;
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 109 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 466 "WindowControl.c"
}


gboolean plank_services_windows_window_control_has_maximized_window (BamfApplication* app) {
	gboolean result = FALSE;
	BamfApplication* _tmp0_;
	GArray* _tmp1_ = NULL;
	GArray* xids;
	GArray* _tmp2_;
#line 112 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, FALSE);
#line 114 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = app;
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = bamf_application_get_xids (_tmp0_);
#line 115 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	xids = _tmp1_;
#line 117 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 117 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp2_ != NULL);
#line 490 "WindowControl.c"
	{
		gint i;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		i = 0;
#line 495 "WindowControl.c"
		{
			gboolean _tmp3_;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp3_ = TRUE;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			while (TRUE) {
#line 502 "WindowControl.c"
				gboolean _tmp4_;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_;
				gboolean _tmp11_;
				GArray* _tmp12_;
				gint _tmp13_;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_;
				WnckWindow* window;
				gboolean _tmp17_ = FALSE;
				WnckWindow* _tmp18_;
				gboolean _tmp21_;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp4_ = _tmp3_;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp4_) {
#line 520 "WindowControl.c"
					gint _tmp5_;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp5_ = i;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					i = _tmp5_ + 1;
#line 526 "WindowControl.c"
				}
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp3_ = FALSE;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp7_ = xids;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp7_ != NULL) {
#line 534 "WindowControl.c"
					gint _tmp8_;
					GArray* _tmp9_;
					guint _tmp10_;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp8_ = i;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp9_ = xids;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp10_ = _tmp9_->len;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
#line 546 "WindowControl.c"
				} else {
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp6_ = FALSE;
#line 550 "WindowControl.c"
				}
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp11_ = _tmp6_;
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp11_) {
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					break;
#line 558 "WindowControl.c"
				}
#line 120 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp12_ = xids;
#line 120 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp13_ = i;
#line 120 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
#line 120 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
#line 120 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp16_ = _g_object_ref0 (_tmp15_);
#line 120 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				window = _tmp16_;
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp18_ = window;
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp18_ != NULL) {
#line 576 "WindowControl.c"
					WnckWindow* _tmp19_;
					gboolean _tmp20_ = FALSE;
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp19_ = window;
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp20_ = wnck_window_is_maximized (_tmp19_);
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp17_ = _tmp20_;
#line 585 "WindowControl.c"
				} else {
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp17_ = FALSE;
#line 589 "WindowControl.c"
				}
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp21_ = _tmp17_;
#line 121 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp21_) {
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					result = TRUE;
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_g_object_unref0 (window);
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_g_array_unref0 (xids);
#line 122 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					return result;
#line 603 "WindowControl.c"
				}
#line 119 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 607 "WindowControl.c"
			}
		}
	}
#line 125 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	result = FALSE;
#line 125 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 125 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 617 "WindowControl.c"
}


gboolean plank_services_windows_window_control_has_minimized_window (BamfApplication* app) {
	gboolean result = FALSE;
	BamfApplication* _tmp0_;
	GArray* _tmp1_ = NULL;
	GArray* xids;
	GArray* _tmp2_;
#line 128 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, FALSE);
#line 130 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = app;
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = bamf_application_get_xids (_tmp0_);
#line 131 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	xids = _tmp1_;
#line 133 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 133 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp2_ != NULL);
#line 641 "WindowControl.c"
	{
		gint i;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		i = 0;
#line 646 "WindowControl.c"
		{
			gboolean _tmp3_;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp3_ = TRUE;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			while (TRUE) {
#line 653 "WindowControl.c"
				gboolean _tmp4_;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_;
				gboolean _tmp11_;
				GArray* _tmp12_;
				gint _tmp13_;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_;
				WnckWindow* window;
				gboolean _tmp17_ = FALSE;
				WnckWindow* _tmp18_;
				gboolean _tmp21_;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp4_ = _tmp3_;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp4_) {
#line 671 "WindowControl.c"
					gint _tmp5_;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp5_ = i;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					i = _tmp5_ + 1;
#line 677 "WindowControl.c"
				}
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp3_ = FALSE;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp7_ = xids;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp7_ != NULL) {
#line 685 "WindowControl.c"
					gint _tmp8_;
					GArray* _tmp9_;
					guint _tmp10_;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp8_ = i;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp9_ = xids;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp10_ = _tmp9_->len;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
#line 697 "WindowControl.c"
				} else {
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp6_ = FALSE;
#line 701 "WindowControl.c"
				}
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp11_ = _tmp6_;
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp11_) {
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					break;
#line 709 "WindowControl.c"
				}
#line 136 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp12_ = xids;
#line 136 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp13_ = i;
#line 136 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
#line 136 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
#line 136 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp16_ = _g_object_ref0 (_tmp15_);
#line 136 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				window = _tmp16_;
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp18_ = window;
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp18_ != NULL) {
#line 727 "WindowControl.c"
					WnckWindow* _tmp19_;
					gboolean _tmp20_ = FALSE;
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp19_ = window;
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp20_ = wnck_window_is_minimized (_tmp19_);
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp17_ = _tmp20_;
#line 736 "WindowControl.c"
				} else {
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp17_ = FALSE;
#line 740 "WindowControl.c"
				}
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp21_ = _tmp17_;
#line 137 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp21_) {
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					result = TRUE;
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_g_object_unref0 (window);
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_g_array_unref0 (xids);
#line 138 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					return result;
#line 754 "WindowControl.c"
				}
#line 135 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 758 "WindowControl.c"
			}
		}
	}
#line 141 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	result = FALSE;
#line 141 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 141 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 768 "WindowControl.c"
}


gboolean plank_services_windows_window_control_has_window_on_workspace (BamfApplication* app, WnckWorkspace* workspace) {
	gboolean result = FALSE;
	BamfApplication* _tmp0_;
	GArray* _tmp1_ = NULL;
	GArray* xids;
	GArray* _tmp2_;
	WnckWorkspace* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean is_virtual;
#line 144 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, FALSE);
#line 144 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_val_if_fail (workspace != NULL, FALSE);
#line 146 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 147 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = app;
#line 147 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = bamf_application_get_xids (_tmp0_);
#line 147 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	xids = _tmp1_;
#line 149 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 149 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp2_ != NULL);
#line 151 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = workspace;
#line 151 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp4_ = wnck_workspace_is_virtual (_tmp3_);
#line 151 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	is_virtual = _tmp4_;
#line 803 "WindowControl.c"
	{
		gint i;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		i = 0;
#line 808 "WindowControl.c"
		{
			gboolean _tmp5_;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp5_ = TRUE;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			while (TRUE) {
#line 815 "WindowControl.c"
				gboolean _tmp6_;
				gboolean _tmp8_ = FALSE;
				GArray* _tmp9_;
				gboolean _tmp13_;
				GArray* _tmp14_;
				gint _tmp15_;
				guint32 _tmp16_ = 0U;
				WnckWindow* _tmp17_ = NULL;
				WnckWindow* _tmp18_;
				WnckWindow* window;
				WnckWindow* _tmp19_;
				gboolean _tmp20_;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp6_ = _tmp5_;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp6_) {
#line 832 "WindowControl.c"
					gint _tmp7_;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp7_ = i;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					i = _tmp7_ + 1;
#line 838 "WindowControl.c"
				}
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp5_ = FALSE;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp9_ = xids;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp9_ != NULL) {
#line 846 "WindowControl.c"
					gint _tmp10_;
					GArray* _tmp11_;
					guint _tmp12_;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp10_ = i;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp11_ = xids;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp12_ = _tmp11_->len;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp8_ = ((guint) _tmp10_) < _tmp12_;
#line 858 "WindowControl.c"
				} else {
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp8_ = FALSE;
#line 862 "WindowControl.c"
				}
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp13_ = _tmp8_;
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp13_) {
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					break;
#line 870 "WindowControl.c"
				}
#line 154 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp14_ = xids;
#line 154 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp15_ = i;
#line 154 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp16_ = g_array_index (_tmp14_, guint32, (guint) _tmp15_);
#line 154 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp17_ = wnck_window_get ((gulong) _tmp16_);
#line 154 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp18_ = _g_object_ref0 (_tmp17_);
#line 154 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				window = _tmp18_;
#line 155 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp19_ = window;
#line 155 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp19_ == NULL) {
#line 156 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_g_object_unref0 (window);
#line 156 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					continue;
#line 892 "WindowControl.c"
				}
#line 158 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp20_ = is_virtual;
#line 158 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp20_) {
#line 898 "WindowControl.c"
					WnckWindow* _tmp21_;
					WnckWorkspace* _tmp22_;
					gboolean _tmp23_ = FALSE;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp21_ = window;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp22_ = workspace;
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp23_ = wnck_window_is_on_workspace (_tmp21_, _tmp22_);
#line 159 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					if (_tmp23_) {
#line 160 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						result = TRUE;
#line 160 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_g_object_unref0 (window);
#line 160 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_g_array_unref0 (xids);
#line 160 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						return result;
#line 918 "WindowControl.c"
					}
				} else {
					WnckWindow* _tmp24_;
					WnckWorkspace* _tmp25_;
					gboolean _tmp26_ = FALSE;
#line 162 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp24_ = window;
#line 162 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp25_ = workspace;
#line 162 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp26_ = wnck_window_is_in_viewport (_tmp24_, _tmp25_);
#line 162 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					if (_tmp26_) {
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						result = TRUE;
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_g_object_unref0 (window);
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_g_array_unref0 (xids);
#line 163 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						return result;
#line 940 "WindowControl.c"
					}
				}
#line 153 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 945 "WindowControl.c"
			}
		}
	}
#line 167 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	result = FALSE;
#line 167 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 167 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 955 "WindowControl.c"
}


GeeArrayList* plank_services_windows_window_control_get_windows (BamfApplication* app) {
	GeeArrayList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* windows;
	BamfApplication* _tmp1_;
	GList* _tmp2_ = NULL;
	GList* children;
	GList* _tmp3_;
	GList* _tmp4_;
#line 170 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 172 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = gee_array_list_new (bamf_window_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 172 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	windows = _tmp0_;
#line 174 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = app;
#line 174 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = bamf_application_get_windows (_tmp1_);
#line 174 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	children = _tmp2_;
#line 176 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = children;
#line 176 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp3_ == NULL) {
#line 177 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		result = windows;
#line 177 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_list_free0 (children);
#line 177 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		return result;
#line 990 "WindowControl.c"
	}
#line 179 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp4_ = children;
#line 994 "WindowControl.c"
	{
		GList* view_collection = NULL;
		GList* view_it = NULL;
#line 179 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		view_collection = _tmp4_;
#line 179 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		for (view_it = view_collection; view_it != NULL; view_it = view_it->next) {
#line 1002 "WindowControl.c"
			BamfView* view = NULL;
#line 179 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			view = (BamfView*) view_it->data;
#line 1006 "WindowControl.c"
			{
				BamfView* _tmp5_;
#line 180 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp5_ = view;
#line 180 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, bamf_window_get_type ())) {
#line 1013 "WindowControl.c"
					GeeArrayList* _tmp6_;
					BamfView* _tmp7_;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp6_ = windows;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp7_ = view;
#line 181 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, bamf_window_get_type ()) ? ((BamfWindow*) _tmp7_) : NULL);
#line 1022 "WindowControl.c"
				}
			}
		}
	}
#line 184 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	result = windows;
#line 184 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_list_free0 (children);
#line 184 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 1033 "WindowControl.c"
}


void plank_services_windows_window_control_update_icon_regions (BamfApplication* app, GdkRectangle* rect) {
	BamfApplication* _tmp0_;
	GArray* _tmp1_ = NULL;
	GArray* xids;
	GArray* _tmp2_;
#line 187 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 187 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (rect != NULL);
#line 189 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 190 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = app;
#line 190 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = bamf_application_get_xids (_tmp0_);
#line 190 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	xids = _tmp1_;
#line 192 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 192 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp2_ != NULL);
#line 1058 "WindowControl.c"
	{
		gint i;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		i = 0;
#line 1063 "WindowControl.c"
		{
			gboolean _tmp3_;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp3_ = TRUE;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			while (TRUE) {
#line 1070 "WindowControl.c"
				gboolean _tmp4_;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_;
				gboolean _tmp11_;
				GArray* _tmp12_;
				gint _tmp13_;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_;
				WnckWindow* window;
				WnckWindow* _tmp17_;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp4_ = _tmp3_;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp4_) {
#line 1086 "WindowControl.c"
					gint _tmp5_;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp5_ = i;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					i = _tmp5_ + 1;
#line 1092 "WindowControl.c"
				}
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp3_ = FALSE;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp7_ = xids;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp7_ != NULL) {
#line 1100 "WindowControl.c"
					gint _tmp8_;
					GArray* _tmp9_;
					guint _tmp10_;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp8_ = i;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp9_ = xids;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp10_ = _tmp9_->len;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
#line 1112 "WindowControl.c"
				} else {
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp6_ = FALSE;
#line 1116 "WindowControl.c"
				}
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp11_ = _tmp6_;
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp11_) {
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					break;
#line 1124 "WindowControl.c"
				}
#line 195 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp12_ = xids;
#line 195 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp13_ = i;
#line 195 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
#line 195 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
#line 195 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp16_ = _g_object_ref0 (_tmp15_);
#line 195 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				window = _tmp16_;
#line 196 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp17_ = window;
#line 196 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp17_ != NULL) {
#line 1142 "WindowControl.c"
					WnckWindow* _tmp18_;
					GdkRectangle _tmp19_;
					gint _tmp20_;
					GdkRectangle _tmp21_;
					gint _tmp22_;
					GdkRectangle _tmp23_;
					gint _tmp24_;
					GdkRectangle _tmp25_;
					gint _tmp26_;
#line 197 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp18_ = window;
#line 197 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp19_ = *rect;
#line 197 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp20_ = _tmp19_.x;
#line 197 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp21_ = *rect;
#line 197 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp22_ = _tmp21_.y;
#line 197 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp23_ = *rect;
#line 197 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp24_ = _tmp23_.width;
#line 197 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp25_ = *rect;
#line 197 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp26_ = _tmp25_.height;
#line 197 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					wnck_window_set_icon_geometry (_tmp18_, _tmp20_, _tmp22_, _tmp24_, _tmp26_);
#line 1172 "WindowControl.c"
				}
#line 194 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 1176 "WindowControl.c"
			}
		}
	}
#line 187 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 1182 "WindowControl.c"
}


void plank_services_windows_window_control_close_all (BamfApplication* app) {
	BamfApplication* _tmp0_;
	GArray* _tmp1_ = NULL;
	GArray* xids;
	GArray* _tmp2_;
#line 201 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 203 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 204 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = app;
#line 204 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = bamf_application_get_xids (_tmp0_);
#line 204 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	xids = _tmp1_;
#line 206 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 206 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp2_ != NULL);
#line 1205 "WindowControl.c"
	{
		gint i;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		i = 0;
#line 1210 "WindowControl.c"
		{
			gboolean _tmp3_;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp3_ = TRUE;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			while (TRUE) {
#line 1217 "WindowControl.c"
				gboolean _tmp4_;
				gboolean _tmp6_ = FALSE;
				GArray* _tmp7_;
				gboolean _tmp11_;
				GArray* _tmp12_;
				gint _tmp13_;
				guint32 _tmp14_ = 0U;
				WnckWindow* _tmp15_ = NULL;
				WnckWindow* _tmp16_;
				WnckWindow* window;
				gboolean _tmp17_ = FALSE;
				WnckWindow* _tmp18_;
				gboolean _tmp21_;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp4_ = _tmp3_;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp4_) {
#line 1235 "WindowControl.c"
					gint _tmp5_;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp5_ = i;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					i = _tmp5_ + 1;
#line 1241 "WindowControl.c"
				}
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp3_ = FALSE;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp7_ = xids;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp7_ != NULL) {
#line 1249 "WindowControl.c"
					gint _tmp8_;
					GArray* _tmp9_;
					guint _tmp10_;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp8_ = i;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp9_ = xids;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp10_ = _tmp9_->len;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp6_ = ((guint) _tmp8_) < _tmp10_;
#line 1261 "WindowControl.c"
				} else {
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp6_ = FALSE;
#line 1265 "WindowControl.c"
				}
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp11_ = _tmp6_;
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp11_) {
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					break;
#line 1273 "WindowControl.c"
				}
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp12_ = xids;
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp13_ = i;
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp14_ = g_array_index (_tmp12_, guint32, (guint) _tmp13_);
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp15_ = wnck_window_get ((gulong) _tmp14_);
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp16_ = _g_object_ref0 (_tmp15_);
#line 209 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				window = _tmp16_;
#line 210 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp18_ = window;
#line 210 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp18_ != NULL) {
#line 1291 "WindowControl.c"
					WnckWindow* _tmp19_;
					gboolean _tmp20_ = FALSE;
#line 210 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp19_ = window;
#line 210 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp20_ = wnck_window_is_skip_tasklist (_tmp19_);
#line 210 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp17_ = !_tmp20_;
#line 1300 "WindowControl.c"
				} else {
#line 210 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp17_ = FALSE;
#line 1304 "WindowControl.c"
				}
#line 210 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp21_ = _tmp17_;
#line 210 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp21_) {
#line 1310 "WindowControl.c"
					WnckWindow* _tmp22_;
					guint32 _tmp23_ = 0U;
#line 211 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp22_ = window;
#line 211 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp23_ = gtk_get_current_event_time ();
#line 211 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					wnck_window_close (_tmp22_, _tmp23_);
#line 1319 "WindowControl.c"
				}
#line 208 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 1323 "WindowControl.c"
			}
		}
	}
#line 201 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 1329 "WindowControl.c"
}


void plank_services_windows_window_control_focus_window (BamfWindow* window) {
	BamfWindow* _tmp0_;
	guint32 _tmp1_ = 0U;
	WnckWindow* _tmp2_ = NULL;
	WnckWindow* _tmp3_;
	WnckWindow* w;
	WnckWindow* _tmp4_;
	WnckWindow* _tmp5_;
	WnckWindow* _tmp6_;
#line 215 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (window != NULL);
#line 217 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 218 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = window;
#line 218 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = bamf_window_get_xid (_tmp0_);
#line 218 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = wnck_window_get ((gulong) _tmp1_);
#line 218 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 218 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	w = _tmp3_;
#line 220 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp4_ = w;
#line 220 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp4_ != NULL);
#line 222 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp5_ = w;
#line 222 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp5_ == NULL) {
#line 223 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (w);
#line 223 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		return;
#line 1368 "WindowControl.c"
	}
#line 225 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp6_ = w;
#line 225 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	plank_services_windows_window_control_center_and_focus_window (_tmp6_);
#line 215 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_object_unref0 (w);
#line 1376 "WindowControl.c"
}


void plank_services_windows_window_control_focus_window_by_xid (guint32 xid) {
	guint32 _tmp0_;
	WnckWindow* _tmp1_ = NULL;
	WnckWindow* _tmp2_;
	WnckWindow* w;
	WnckWindow* _tmp3_;
	WnckWindow* _tmp4_;
	WnckWindow* _tmp5_;
#line 230 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = xid;
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = wnck_window_get ((gulong) _tmp0_);
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 231 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	w = _tmp2_;
#line 233 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = w;
#line 233 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp3_ != NULL);
#line 235 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp4_ = w;
#line 235 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp4_ == NULL) {
#line 236 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (w);
#line 236 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		return;
#line 1410 "WindowControl.c"
	}
#line 238 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp5_ = w;
#line 238 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	plank_services_windows_window_control_center_and_focus_window (_tmp5_);
#line 228 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_object_unref0 (w);
#line 1418 "WindowControl.c"
}


void plank_services_windows_window_control_focus (BamfApplication* app) {
#line 241 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 1425 "WindowControl.c"
	{
		BamfApplication* _tmp0_;
		GeeArrayList* _tmp1_ = NULL;
		GeeArrayList* _window_list;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _window_size;
		gint _window_index;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp0_ = app;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_list = _tmp1_;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp2_ = _window_list;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp4_ = _tmp3_;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_size = _tmp4_;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_index = -1;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		while (TRUE) {
#line 1453 "WindowControl.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_ = NULL;
			WnckWindow* window;
			WnckWindow* _tmp11_;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp5_ = _window_index;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_window_index = _tmp5_ + 1;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp6_ = _window_index;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp7_ = _window_size;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				break;
#line 1474 "WindowControl.c"
			}
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp8_ = _window_list;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp9_ = _window_index;
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			window = (WnckWindow*) _tmp10_;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp11_ = window;
#line 244 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			plank_services_windows_window_control_center_and_focus_window (_tmp11_);
#line 245 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_g_object_unref0 (window);
#line 1492 "WindowControl.c"
		}
#line 243 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (_window_list);
#line 1496 "WindowControl.c"
	}
}


static gint plank_services_windows_window_control_find_active_xid_index (GArray* xids) {
	gint result = 0;
	gint i;
#line 251 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	i = 0;
#line 1506 "WindowControl.c"
	{
		gboolean _tmp0_;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp0_ = TRUE;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		while (TRUE) {
#line 1513 "WindowControl.c"
			gboolean _tmp1_;
			gboolean _tmp3_ = FALSE;
			GArray* _tmp4_;
			gboolean _tmp8_;
			GArray* _tmp9_;
			gint _tmp10_;
			guint32 _tmp11_ = 0U;
			WnckWindow* _tmp12_ = NULL;
			WnckWindow* _tmp13_;
			WnckWindow* window;
			gboolean _tmp14_ = FALSE;
			WnckWindow* _tmp15_;
			gboolean _tmp18_;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp1_ = _tmp0_;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!_tmp1_) {
#line 1531 "WindowControl.c"
				gint _tmp2_;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp2_ = i;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				i = _tmp2_ + 1;
#line 1537 "WindowControl.c"
			}
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp0_ = FALSE;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp4_ = xids;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp4_ != NULL) {
#line 1545 "WindowControl.c"
				gint _tmp5_;
				GArray* _tmp6_;
				guint _tmp7_;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp5_ = i;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp6_ = xids;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp7_ = _tmp6_->len;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp3_ = ((guint) _tmp5_) < _tmp7_;
#line 1557 "WindowControl.c"
			} else {
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp3_ = FALSE;
#line 1561 "WindowControl.c"
			}
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp8_ = _tmp3_;
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!_tmp8_) {
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				break;
#line 1569 "WindowControl.c"
			}
#line 253 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp9_ = xids;
#line 253 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp10_ = i;
#line 253 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp11_ = g_array_index (_tmp9_, guint32, (guint) _tmp10_);
#line 253 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp12_ = wnck_window_get ((gulong) _tmp11_);
#line 253 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 253 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			window = _tmp13_;
#line 254 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp15_ = window;
#line 254 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp15_ != NULL) {
#line 1587 "WindowControl.c"
				WnckWindow* _tmp16_;
				gboolean _tmp17_ = FALSE;
#line 254 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp16_ = window;
#line 254 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp17_ = wnck_window_is_active (_tmp16_);
#line 254 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp14_ = _tmp17_;
#line 1596 "WindowControl.c"
			} else {
#line 254 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp14_ = FALSE;
#line 1600 "WindowControl.c"
			}
#line 254 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp18_ = _tmp14_;
#line 254 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp18_) {
#line 255 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 255 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				break;
#line 1610 "WindowControl.c"
			}
#line 252 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_g_object_unref0 (window);
#line 1614 "WindowControl.c"
		}
	}
#line 257 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	result = i;
#line 257 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 1621 "WindowControl.c"
}


void plank_services_windows_window_control_focus_previous (BamfApplication* app) {
	BamfApplication* _tmp0_;
	GArray* _tmp1_ = NULL;
	GArray* xids;
	GArray* _tmp2_;
	GArray* _tmp3_;
	GArray* _tmp4_;
	gint _tmp5_ = 0;
	gint i;
	gint _tmp6_ = 0;
	gint _tmp7_;
	GArray* _tmp8_;
	guint _tmp9_;
	gint _tmp11_;
	gint _tmp12_;
	GArray* _tmp15_;
	gint _tmp16_;
	guint32 _tmp17_ = 0U;
#line 260 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 262 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 263 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = app;
#line 263 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = bamf_application_get_xids (_tmp0_);
#line 263 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	xids = _tmp1_;
#line 265 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 265 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp2_ != NULL);
#line 267 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = xids;
#line 267 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp3_ == NULL) {
#line 268 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_array_unref0 (xids);
#line 268 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		return;
#line 1665 "WindowControl.c"
	}
#line 270 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp4_ = xids;
#line 270 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp5_ = plank_services_windows_window_control_find_active_xid_index (_tmp4_);
#line 270 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	i = _tmp5_;
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp7_ = i;
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp8_ = xids;
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp9_ = _tmp8_->len;
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (((guint) _tmp7_) < _tmp9_) {
#line 1681 "WindowControl.c"
		gint _tmp10_;
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp10_ = i;
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp6_ = _tmp10_ - 1;
#line 1687 "WindowControl.c"
	} else {
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp6_ = 0;
#line 1691 "WindowControl.c"
	}
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp11_ = _tmp6_;
#line 271 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	i = _tmp11_;
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp12_ = i;
#line 273 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp12_ < 0) {
#line 1701 "WindowControl.c"
		GArray* _tmp13_;
		guint _tmp14_;
#line 274 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp13_ = xids;
#line 274 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp14_ = _tmp13_->len;
#line 274 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		i = ((gint) _tmp14_) - 1;
#line 1710 "WindowControl.c"
	}
#line 276 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp15_ = xids;
#line 276 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp16_ = i;
#line 276 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp17_ = g_array_index (_tmp15_, guint32, (guint) _tmp16_);
#line 276 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	plank_services_windows_window_control_focus_window_by_xid (_tmp17_);
#line 260 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 1722 "WindowControl.c"
}


void plank_services_windows_window_control_focus_next (BamfApplication* app) {
	BamfApplication* _tmp0_;
	GArray* _tmp1_ = NULL;
	GArray* xids;
	GArray* _tmp2_;
	GArray* _tmp3_;
	GArray* _tmp4_;
	gint _tmp5_ = 0;
	gint i;
	gint _tmp6_ = 0;
	gint _tmp7_;
	GArray* _tmp8_;
	guint _tmp9_;
	gint _tmp11_;
	gint _tmp12_;
	GArray* _tmp13_;
	guint _tmp14_;
	GArray* _tmp15_;
	gint _tmp16_;
	guint32 _tmp17_ = 0U;
#line 279 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 281 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 282 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = app;
#line 282 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = bamf_application_get_xids (_tmp0_);
#line 282 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	xids = _tmp1_;
#line 284 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 284 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp2_ != NULL);
#line 286 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = xids;
#line 286 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp3_ == NULL) {
#line 287 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_array_unref0 (xids);
#line 287 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		return;
#line 1768 "WindowControl.c"
	}
#line 289 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp4_ = xids;
#line 289 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp5_ = plank_services_windows_window_control_find_active_xid_index (_tmp4_);
#line 289 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	i = _tmp5_;
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp7_ = i;
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp8_ = xids;
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp9_ = _tmp8_->len;
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (((guint) _tmp7_) < _tmp9_) {
#line 1784 "WindowControl.c"
		gint _tmp10_;
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp10_ = i;
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp6_ = _tmp10_ + 1;
#line 1790 "WindowControl.c"
	} else {
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp6_ = 0;
#line 1794 "WindowControl.c"
	}
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp11_ = _tmp6_;
#line 290 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	i = _tmp11_;
#line 292 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp12_ = i;
#line 292 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp13_ = xids;
#line 292 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp14_ = _tmp13_->len;
#line 292 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (((guint) _tmp12_) == _tmp14_) {
#line 293 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		i = 0;
#line 1810 "WindowControl.c"
	}
#line 295 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp15_ = xids;
#line 295 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp16_ = i;
#line 295 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp17_ = g_array_index (_tmp15_, guint32, (guint) _tmp16_);
#line 295 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	plank_services_windows_window_control_focus_window_by_xid (_tmp17_);
#line 279 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 1822 "WindowControl.c"
}


void plank_services_windows_window_control_minimize (BamfApplication* app) {
#line 298 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 1829 "WindowControl.c"
	{
		BamfApplication* _tmp0_;
		GeeArrayList* _tmp1_ = NULL;
		GeeArrayList* _window_list;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _window_size;
		gint _window_index;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp0_ = app;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_list = _tmp1_;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp2_ = _window_list;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp4_ = _tmp3_;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_size = _tmp4_;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_index = -1;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		while (TRUE) {
#line 1857 "WindowControl.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_ = NULL;
			WnckWindow* window;
			gboolean _tmp11_ = FALSE;
			WnckWindow* _tmp12_;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp19_;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp5_ = _window_index;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_window_index = _tmp5_ + 1;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp6_ = _window_index;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp7_ = _window_size;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				break;
#line 1881 "WindowControl.c"
			}
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp8_ = _window_list;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp9_ = _window_index;
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			window = (WnckWindow*) _tmp10_;
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp12_ = window;
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp13_ = wnck_window_is_minimized (_tmp12_);
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!_tmp13_) {
#line 1897 "WindowControl.c"
				WnckWindow* _tmp14_;
				WnckWindow* _tmp15_;
				WnckScreen* _tmp16_ = NULL;
				WnckWorkspace* _tmp17_ = NULL;
				gboolean _tmp18_ = FALSE;
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp14_ = window;
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp15_ = window;
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp16_ = wnck_window_get_screen (_tmp15_);
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp17_ = wnck_screen_get_active_workspace (_tmp16_);
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp18_ = wnck_window_is_in_viewport (_tmp14_, _tmp17_);
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp11_ = _tmp18_;
#line 1915 "WindowControl.c"
			} else {
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp11_ = FALSE;
#line 1919 "WindowControl.c"
			}
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp19_ = _tmp11_;
#line 301 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp19_) {
#line 1925 "WindowControl.c"
				WnckWindow* _tmp20_;
#line 302 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp20_ = window;
#line 302 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				wnck_window_minimize (_tmp20_);
#line 303 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 1933 "WindowControl.c"
			}
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_g_object_unref0 (window);
#line 1937 "WindowControl.c"
		}
#line 300 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (_window_list);
#line 1941 "WindowControl.c"
	}
}


void plank_services_windows_window_control_restore (BamfApplication* app) {
	BamfApplication* _tmp0_;
	GeeArrayList* _tmp1_ = NULL;
	GeeArrayList* stack;
#line 307 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 309 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = app;
#line 309 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
#line 309 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	stack = _tmp1_;
#line 1958 "WindowControl.c"
	{
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint i;
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp2_ = stack;
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp4_ = _tmp3_;
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		i = ((gint) _tmp4_) - 1;
#line 1972 "WindowControl.c"
		{
			gboolean _tmp5_;
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp5_ = TRUE;
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			while (TRUE) {
#line 1979 "WindowControl.c"
				gboolean _tmp6_;
				gint _tmp8_;
				GeeArrayList* _tmp9_;
				gint _tmp10_;
				gpointer _tmp11_ = NULL;
				WnckWindow* window;
				gboolean _tmp12_ = FALSE;
				WnckWindow* _tmp13_;
				gboolean _tmp14_ = FALSE;
				gboolean _tmp20_;
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp6_ = _tmp5_;
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp6_) {
#line 1994 "WindowControl.c"
					gint _tmp7_;
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp7_ = i;
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					i = _tmp7_ - 1;
#line 2000 "WindowControl.c"
				}
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp5_ = FALSE;
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp8_ = i;
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!(_tmp8_ >= 0)) {
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					break;
#line 2010 "WindowControl.c"
				}
#line 311 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp9_ = stack;
#line 311 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp10_ = i;
#line 311 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 311 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				window = (WnckWindow*) _tmp11_;
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp13_ = window;
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp14_ = wnck_window_is_minimized (_tmp13_);
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp14_) {
#line 2026 "WindowControl.c"
					WnckWindow* _tmp15_;
					WnckWindow* _tmp16_;
					WnckScreen* _tmp17_ = NULL;
					WnckWorkspace* _tmp18_ = NULL;
					gboolean _tmp19_ = FALSE;
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp15_ = window;
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp16_ = window;
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp17_ = wnck_window_get_screen (_tmp16_);
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp18_ = wnck_screen_get_active_workspace (_tmp17_);
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp19_ = wnck_window_is_in_viewport (_tmp15_, _tmp18_);
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp12_ = _tmp19_;
#line 2044 "WindowControl.c"
				} else {
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp12_ = FALSE;
#line 2048 "WindowControl.c"
				}
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp20_ = _tmp12_;
#line 312 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp20_) {
#line 2054 "WindowControl.c"
					WnckWindow* _tmp21_;
					guint32 _tmp22_ = 0U;
#line 313 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp21_ = window;
#line 313 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp22_ = gtk_get_current_event_time ();
#line 313 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					wnck_window_unminimize (_tmp21_, _tmp22_);
#line 314 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 2065 "WindowControl.c"
				}
#line 310 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 2069 "WindowControl.c"
			}
		}
	}
#line 307 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_object_unref0 (stack);
#line 2075 "WindowControl.c"
}


void plank_services_windows_window_control_maximize (BamfApplication* app) {
#line 319 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 2082 "WindowControl.c"
	{
		BamfApplication* _tmp0_;
		GeeArrayList* _tmp1_ = NULL;
		GeeArrayList* _window_list;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _window_size;
		gint _window_index;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp0_ = app;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_list = _tmp1_;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp2_ = _window_list;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp4_ = _tmp3_;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_size = _tmp4_;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_index = -1;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		while (TRUE) {
#line 2110 "WindowControl.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_ = NULL;
			WnckWindow* window;
			WnckWindow* _tmp11_;
			gboolean _tmp12_ = FALSE;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp5_ = _window_index;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_window_index = _tmp5_ + 1;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp6_ = _window_index;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp7_ = _window_size;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				break;
#line 2132 "WindowControl.c"
			}
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp8_ = _window_list;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp9_ = _window_index;
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			window = (WnckWindow*) _tmp10_;
#line 322 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp11_ = window;
#line 322 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp12_ = wnck_window_is_maximized (_tmp11_);
#line 322 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!_tmp12_) {
#line 2148 "WindowControl.c"
				WnckWindow* _tmp13_;
#line 323 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp13_ = window;
#line 323 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				wnck_window_maximize (_tmp13_);
#line 2154 "WindowControl.c"
			}
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_g_object_unref0 (window);
#line 2158 "WindowControl.c"
		}
#line 321 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (_window_list);
#line 2162 "WindowControl.c"
	}
}


void plank_services_windows_window_control_unmaximize (BamfApplication* app) {
#line 326 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 2170 "WindowControl.c"
	{
		BamfApplication* _tmp0_;
		GeeArrayList* _tmp1_ = NULL;
		GeeArrayList* _window_list;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _window_size;
		gint _window_index;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp0_ = app;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_list = _tmp1_;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp2_ = _window_list;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp4_ = _tmp3_;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_size = _tmp4_;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_index = -1;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		while (TRUE) {
#line 2198 "WindowControl.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_ = NULL;
			WnckWindow* window;
			WnckWindow* _tmp11_;
			gboolean _tmp12_ = FALSE;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp5_ = _window_index;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_window_index = _tmp5_ + 1;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp6_ = _window_index;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp7_ = _window_size;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				break;
#line 2220 "WindowControl.c"
			}
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp8_ = _window_list;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp9_ = _window_index;
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			window = (WnckWindow*) _tmp10_;
#line 329 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp11_ = window;
#line 329 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp12_ = wnck_window_is_maximized (_tmp11_);
#line 329 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp12_) {
#line 2236 "WindowControl.c"
				WnckWindow* _tmp13_;
#line 330 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp13_ = window;
#line 330 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				wnck_window_unmaximize (_tmp13_);
#line 2242 "WindowControl.c"
			}
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_g_object_unref0 (window);
#line 2246 "WindowControl.c"
		}
#line 328 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (_window_list);
#line 2250 "WindowControl.c"
	}
}


GeeArrayList* plank_services_windows_window_control_get_ordered_window_stack (BamfApplication* app) {
	GeeArrayList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* windows;
	BamfApplication* _tmp1_;
	GArray* _tmp2_ = NULL;
	GArray* xids;
	GArray* _tmp3_;
	GArray* _tmp4_;
	WnckScreen* _tmp5_ = NULL;
	GList* _tmp6_ = NULL;
	GList* stack;
	GList* _tmp7_;
#line 333 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = gee_array_list_new (wnck_window_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 335 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	windows = _tmp0_;
#line 337 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 338 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = app;
#line 338 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = bamf_application_get_xids (_tmp1_);
#line 338 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	xids = _tmp2_;
#line 340 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = xids;
#line 340 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp3_ != NULL);
#line 342 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp4_ = xids;
#line 342 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp4_ == NULL) {
#line 343 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		result = windows;
#line 343 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_array_unref0 (xids);
#line 343 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		return result;
#line 2296 "WindowControl.c"
	}
#line 345 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp5_ = wnck_screen_get_default ();
#line 345 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp6_ = wnck_screen_get_windows_stacked (_tmp5_);
#line 345 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	stack = _tmp6_;
#line 347 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp7_ = stack;
#line 2306 "WindowControl.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 347 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		window_collection = _tmp7_;
#line 347 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 2314 "WindowControl.c"
			WnckWindow* _tmp8_;
			WnckWindow* window = NULL;
#line 347 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp8_ = _g_object_ref0 ((WnckWindow*) window_it->data);
#line 347 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			window = _tmp8_;
#line 2321 "WindowControl.c"
			{
				{
					gint j;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					j = 0;
#line 2327 "WindowControl.c"
					{
						gboolean _tmp9_;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp9_ = TRUE;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						while (TRUE) {
#line 2334 "WindowControl.c"
							gboolean _tmp10_;
							gint _tmp12_;
							GArray* _tmp13_;
							guint _tmp14_;
							GArray* _tmp15_;
							gint _tmp16_;
							guint32 _tmp17_ = 0U;
							WnckWindow* _tmp18_;
							gulong _tmp19_ = 0UL;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp10_ = _tmp9_;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							if (!_tmp10_) {
#line 2348 "WindowControl.c"
								gint _tmp11_;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
								_tmp11_ = j;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
								j = _tmp11_ + 1;
#line 2354 "WindowControl.c"
							}
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp9_ = FALSE;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp12_ = j;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp13_ = xids;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp14_ = _tmp13_->len;
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							if (!(((guint) _tmp12_) < _tmp14_)) {
#line 348 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
								break;
#line 2368 "WindowControl.c"
							}
#line 349 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp15_ = xids;
#line 349 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp16_ = j;
#line 349 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp17_ = g_array_index (_tmp15_, guint32, (guint) _tmp16_);
#line 349 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp18_ = window;
#line 349 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp19_ = wnck_window_get_xid (_tmp18_);
#line 349 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							if (((gulong) _tmp17_) == _tmp19_) {
#line 2382 "WindowControl.c"
								GeeArrayList* _tmp20_;
								WnckWindow* _tmp21_;
#line 350 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
								_tmp20_ = windows;
#line 350 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
								_tmp21_ = window;
#line 350 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 2391 "WindowControl.c"
							}
						}
					}
				}
#line 347 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 2398 "WindowControl.c"
			}
		}
	}
#line 352 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	result = windows;
#line 352 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 352 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 2408 "WindowControl.c"
}


void plank_services_windows_window_control_smart_focus (BamfApplication* app) {
	BamfApplication* _tmp0_;
	GeeArrayList* _tmp1_ = NULL;
	GeeArrayList* windows;
	gboolean not_in_viewport;
	gboolean urgent;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_;
	gboolean _tmp27_;
#line 355 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 357 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = app;
#line 357 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = plank_services_windows_window_control_get_ordered_window_stack (_tmp0_);
#line 357 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	windows = _tmp1_;
#line 359 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	not_in_viewport = TRUE;
#line 360 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	urgent = FALSE;
#line 2433 "WindowControl.c"
	{
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
		GeeArrayList* _window_list;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _window_size;
		gint _window_index;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp2_ = windows;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_list = _tmp3_;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp4_ = _window_list;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp4_);
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp6_ = _tmp5_;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_size = _tmp6_;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_index = -1;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		while (TRUE) {
#line 2461 "WindowControl.c"
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			GeeArrayList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_ = NULL;
			WnckWindow* window;
			gboolean _tmp13_ = FALSE;
			WnckWindow* _tmp14_;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp21_;
			WnckWindow* _tmp22_;
			gboolean _tmp23_ = FALSE;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp7_ = _window_index;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_window_index = _tmp7_ + 1;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp8_ = _window_index;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp9_ = _window_size;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				break;
#line 2487 "WindowControl.c"
			}
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp10_ = _window_list;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp11_ = _window_index;
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			window = (WnckWindow*) _tmp12_;
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp14_ = window;
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp15_ = wnck_window_is_skip_tasklist (_tmp14_);
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!_tmp15_) {
#line 2503 "WindowControl.c"
				WnckWindow* _tmp16_;
				WnckWindow* _tmp17_;
				WnckScreen* _tmp18_ = NULL;
				WnckWorkspace* _tmp19_ = NULL;
				gboolean _tmp20_ = FALSE;
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp16_ = window;
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp17_ = window;
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp18_ = wnck_window_get_screen (_tmp17_);
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp19_ = wnck_screen_get_active_workspace (_tmp18_);
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp20_ = wnck_window_is_in_viewport (_tmp16_, _tmp19_);
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp13_ = _tmp20_;
#line 2521 "WindowControl.c"
			} else {
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp13_ = FALSE;
#line 2525 "WindowControl.c"
			}
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp21_ = _tmp13_;
#line 363 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp21_) {
#line 364 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				not_in_viewport = FALSE;
#line 2533 "WindowControl.c"
			}
#line 365 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp22_ = window;
#line 365 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp23_ = wnck_window_needs_attention (_tmp22_);
#line 365 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp23_) {
#line 366 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				urgent = TRUE;
#line 2543 "WindowControl.c"
			}
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_g_object_unref0 (window);
#line 2547 "WindowControl.c"
		}
#line 362 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (_window_list);
#line 2551 "WindowControl.c"
	}
#line 369 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp25_ = not_in_viewport;
#line 369 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp25_) {
#line 369 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp24_ = TRUE;
#line 2559 "WindowControl.c"
	} else {
		gboolean _tmp26_;
#line 369 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp26_ = urgent;
#line 369 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp24_ = _tmp26_;
#line 2566 "WindowControl.c"
	}
#line 369 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp27_ = _tmp24_;
#line 369 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp27_) {
#line 2572 "WindowControl.c"
		{
			GeeArrayList* _tmp28_;
			GeeArrayList* _tmp29_;
			GeeArrayList* _window_list;
			GeeArrayList* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			gint _window_size;
			gint _window_index;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp28_ = windows;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp29_ = _g_object_ref0 (_tmp28_);
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_window_list = _tmp29_;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp30_ = _window_list;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp31_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp30_);
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp32_ = _tmp31_;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_window_size = _tmp32_;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_window_index = -1;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			while (TRUE) {
#line 2600 "WindowControl.c"
				gint _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				GeeArrayList* _tmp36_;
				gint _tmp37_;
				gpointer _tmp38_ = NULL;
				WnckWindow* window;
				gboolean _tmp39_ = FALSE;
				gboolean _tmp40_;
				gboolean _tmp43_;
				WnckWindow* _tmp44_;
				gboolean _tmp45_ = FALSE;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp33_ = _window_index;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_window_index = _tmp33_ + 1;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp34_ = _window_index;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp35_ = _window_size;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!(_tmp34_ < _tmp35_)) {
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					break;
#line 2625 "WindowControl.c"
				}
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp36_ = _window_list;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp37_ = _window_index;
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp38_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, _tmp37_);
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				window = (WnckWindow*) _tmp38_;
#line 371 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp40_ = urgent;
#line 371 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp40_) {
#line 2639 "WindowControl.c"
					WnckWindow* _tmp41_;
					gboolean _tmp42_ = FALSE;
#line 371 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp41_ = window;
#line 371 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp42_ = wnck_window_needs_attention (_tmp41_);
#line 371 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp39_ = !_tmp42_;
#line 2648 "WindowControl.c"
				} else {
#line 371 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp39_ = FALSE;
#line 2652 "WindowControl.c"
				}
#line 371 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp43_ = _tmp39_;
#line 371 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (_tmp43_) {
#line 372 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_g_object_unref0 (window);
#line 372 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					continue;
#line 2662 "WindowControl.c"
				}
#line 374 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp44_ = window;
#line 374 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp45_ = wnck_window_is_skip_tasklist (_tmp44_);
#line 374 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				if (!_tmp45_) {
#line 2670 "WindowControl.c"
					WnckWindow* _tmp46_;
					GeeArrayList* _tmp47_;
#line 375 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp46_ = window;
#line 375 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp47_ = windows;
#line 375 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					plank_services_windows_window_control_intelligent_focus_off_viewport_window (_tmp46_, _tmp47_);
#line 376 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_g_object_unref0 (window);
#line 376 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_g_object_unref0 (_window_list);
#line 376 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_g_object_unref0 (windows);
#line 376 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					return;
#line 2687 "WindowControl.c"
				}
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 2691 "WindowControl.c"
			}
#line 370 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_g_object_unref0 (_window_list);
#line 2695 "WindowControl.c"
		}
	}
	{
		GeeArrayList* _tmp48_;
		GeeArrayList* _tmp49_;
		GeeArrayList* _window_list;
		GeeArrayList* _tmp50_;
		gint _tmp51_;
		gint _tmp52_;
		gint _window_size;
		gint _window_index;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp48_ = windows;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp49_ = _g_object_ref0 (_tmp48_);
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_list = _tmp49_;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp50_ = _window_list;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp51_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp50_);
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp52_ = _tmp51_;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_size = _tmp52_;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_index = -1;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		while (TRUE) {
#line 2725 "WindowControl.c"
			gint _tmp53_;
			gint _tmp54_;
			gint _tmp55_;
			GeeArrayList* _tmp56_;
			gint _tmp57_;
			gpointer _tmp58_ = NULL;
			WnckWindow* window;
			gboolean _tmp59_ = FALSE;
			WnckWindow* _tmp60_;
			gboolean _tmp61_ = FALSE;
			gboolean _tmp67_;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp53_ = _window_index;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_window_index = _tmp53_ + 1;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp54_ = _window_index;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp55_ = _window_size;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!(_tmp54_ < _tmp55_)) {
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				break;
#line 2749 "WindowControl.c"
			}
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp56_ = _window_list;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp57_ = _window_index;
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp58_ = gee_abstract_list_get ((GeeAbstractList*) _tmp56_, _tmp57_);
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			window = (WnckWindow*) _tmp58_;
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp60_ = window;
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp61_ = wnck_window_is_minimized (_tmp60_);
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp61_) {
#line 2765 "WindowControl.c"
				WnckWindow* _tmp62_;
				WnckWindow* _tmp63_;
				WnckScreen* _tmp64_ = NULL;
				WnckWorkspace* _tmp65_ = NULL;
				gboolean _tmp66_ = FALSE;
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp62_ = window;
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp63_ = window;
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp64_ = wnck_window_get_screen (_tmp63_);
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp65_ = wnck_screen_get_active_workspace (_tmp64_);
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp66_ = wnck_window_is_in_viewport (_tmp62_, _tmp65_);
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp59_ = _tmp66_;
#line 2783 "WindowControl.c"
			} else {
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp59_ = FALSE;
#line 2787 "WindowControl.c"
			}
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp67_ = _tmp59_;
#line 382 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp67_) {
#line 2793 "WindowControl.c"
				{
					GeeArrayList* _tmp68_;
					GeeArrayList* _tmp69_;
					GeeArrayList* _w_list;
					GeeArrayList* _tmp70_;
					gint _tmp71_;
					gint _tmp72_;
					gint _w_size;
					gint _w_index;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp68_ = windows;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp69_ = _g_object_ref0 (_tmp68_);
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_w_list = _tmp69_;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp70_ = _w_list;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp71_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp70_);
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp72_ = _tmp71_;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_w_size = _tmp72_;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_w_index = -1;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					while (TRUE) {
#line 2821 "WindowControl.c"
						gint _tmp73_;
						gint _tmp74_;
						gint _tmp75_;
						GeeArrayList* _tmp76_;
						gint _tmp77_;
						gpointer _tmp78_ = NULL;
						WnckWindow* w;
						gboolean _tmp79_ = FALSE;
						WnckWindow* _tmp80_;
						gboolean _tmp81_ = FALSE;
						gboolean _tmp87_;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp73_ = _w_index;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_w_index = _tmp73_ + 1;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp74_ = _w_index;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp75_ = _w_size;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						if (!(_tmp74_ < _tmp75_)) {
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							break;
#line 2845 "WindowControl.c"
						}
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp76_ = _w_list;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp77_ = _w_index;
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp78_ = gee_abstract_list_get ((GeeAbstractList*) _tmp76_, _tmp77_);
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						w = (WnckWindow*) _tmp78_;
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp80_ = w;
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp81_ = wnck_window_is_minimized (_tmp80_);
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						if (_tmp81_) {
#line 2861 "WindowControl.c"
							WnckWindow* _tmp82_;
							WnckWindow* _tmp83_;
							WnckScreen* _tmp84_ = NULL;
							WnckWorkspace* _tmp85_ = NULL;
							gboolean _tmp86_ = FALSE;
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp82_ = w;
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp83_ = w;
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp84_ = wnck_window_get_screen (_tmp83_);
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp85_ = wnck_screen_get_active_workspace (_tmp84_);
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp86_ = wnck_window_is_in_viewport (_tmp82_, _tmp85_);
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp79_ = _tmp86_;
#line 2879 "WindowControl.c"
						} else {
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp79_ = FALSE;
#line 2883 "WindowControl.c"
						}
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp87_ = _tmp79_;
#line 384 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						if (_tmp87_) {
#line 2889 "WindowControl.c"
							WnckWindow* _tmp88_;
							guint32 _tmp89_ = 0U;
#line 385 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp88_ = w;
#line 385 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp89_ = gtk_get_current_event_time ();
#line 385 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							wnck_window_unminimize (_tmp88_, _tmp89_);
#line 386 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 2900 "WindowControl.c"
						}
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_g_object_unref0 (w);
#line 2904 "WindowControl.c"
					}
#line 383 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_g_object_unref0 (_w_list);
#line 2908 "WindowControl.c"
				}
#line 388 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 388 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (_window_list);
#line 388 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (windows);
#line 388 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				return;
#line 2918 "WindowControl.c"
			}
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_g_object_unref0 (window);
#line 2922 "WindowControl.c"
		}
#line 381 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (_window_list);
#line 2926 "WindowControl.c"
	}
	{
		GeeArrayList* _tmp90_;
		GeeArrayList* _tmp91_;
		GeeArrayList* _window_list;
		GeeArrayList* _tmp92_;
		gint _tmp93_;
		gint _tmp94_;
		gint _window_size;
		gint _window_index;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp90_ = windows;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp91_ = _g_object_ref0 (_tmp90_);
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_list = _tmp91_;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp92_ = _window_list;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp93_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp92_);
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp94_ = _tmp93_;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_size = _tmp94_;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_index = -1;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		while (TRUE) {
#line 2955 "WindowControl.c"
			gint _tmp95_;
			gint _tmp96_;
			gint _tmp97_;
			GeeArrayList* _tmp98_;
			gint _tmp99_;
			gpointer _tmp100_ = NULL;
			WnckWindow* window;
			gboolean _tmp101_ = FALSE;
			gboolean _tmp102_ = FALSE;
			WnckWindow* _tmp103_;
			gboolean _tmp104_ = FALSE;
			gboolean _tmp110_;
			gboolean _tmp114_;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp95_ = _window_index;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_window_index = _tmp95_ + 1;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp96_ = _window_index;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp97_ = _window_size;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!(_tmp96_ < _tmp97_)) {
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				break;
#line 2981 "WindowControl.c"
			}
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp98_ = _window_list;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp99_ = _window_index;
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp100_ = gee_abstract_list_get ((GeeAbstractList*) _tmp98_, _tmp99_);
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			window = (WnckWindow*) _tmp100_;
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp103_ = window;
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp104_ = wnck_window_is_active (_tmp103_);
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp104_) {
#line 2997 "WindowControl.c"
				WnckWindow* _tmp105_;
				WnckWindow* _tmp106_;
				WnckScreen* _tmp107_ = NULL;
				WnckWorkspace* _tmp108_ = NULL;
				gboolean _tmp109_ = FALSE;
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp105_ = window;
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp106_ = window;
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp107_ = wnck_window_get_screen (_tmp106_);
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp108_ = wnck_screen_get_active_workspace (_tmp107_);
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp109_ = wnck_window_is_in_viewport (_tmp105_, _tmp108_);
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp102_ = _tmp109_;
#line 3015 "WindowControl.c"
			} else {
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp102_ = FALSE;
#line 3019 "WindowControl.c"
			}
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp110_ = _tmp102_;
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp110_) {
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp101_ = TRUE;
#line 3027 "WindowControl.c"
			} else {
				WnckWindow* _tmp111_;
				WnckScreen* _tmp112_ = NULL;
				WnckWindow* _tmp113_ = NULL;
#line 393 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp111_ = window;
#line 393 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp112_ = wnck_screen_get_default ();
#line 393 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp113_ = wnck_screen_get_active_window (_tmp112_);
#line 393 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_tmp101_ = _tmp111_ == _tmp113_;
#line 3040 "WindowControl.c"
			}
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp114_ = _tmp101_;
#line 392 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (_tmp114_) {
#line 3046 "WindowControl.c"
				{
					GeeArrayList* _tmp115_;
					GeeArrayList* _tmp116_;
					GeeArrayList* _w_list;
					GeeArrayList* _tmp117_;
					gint _tmp118_;
					gint _tmp119_;
					gint _w_size;
					gint _w_index;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp115_ = windows;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp116_ = _g_object_ref0 (_tmp115_);
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_w_list = _tmp116_;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp117_ = _w_list;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp118_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp117_);
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_tmp119_ = _tmp118_;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_w_size = _tmp119_;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_w_index = -1;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					while (TRUE) {
#line 3074 "WindowControl.c"
						gint _tmp120_;
						gint _tmp121_;
						gint _tmp122_;
						GeeArrayList* _tmp123_;
						gint _tmp124_;
						gpointer _tmp125_ = NULL;
						WnckWindow* w;
						gboolean _tmp126_ = FALSE;
						WnckWindow* _tmp127_;
						gboolean _tmp128_ = FALSE;
						gboolean _tmp134_;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp120_ = _w_index;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_w_index = _tmp120_ + 1;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp121_ = _w_index;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp122_ = _w_size;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						if (!(_tmp121_ < _tmp122_)) {
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							break;
#line 3098 "WindowControl.c"
						}
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp123_ = _w_list;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp124_ = _w_index;
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp125_ = gee_abstract_list_get ((GeeAbstractList*) _tmp123_, _tmp124_);
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						w = (WnckWindow*) _tmp125_;
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp127_ = w;
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp128_ = wnck_window_is_minimized (_tmp127_);
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						if (!_tmp128_) {
#line 3114 "WindowControl.c"
							WnckWindow* _tmp129_;
							WnckWindow* _tmp130_;
							WnckScreen* _tmp131_ = NULL;
							WnckWorkspace* _tmp132_ = NULL;
							gboolean _tmp133_ = FALSE;
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp129_ = w;
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp130_ = w;
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp131_ = wnck_window_get_screen (_tmp130_);
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp132_ = wnck_screen_get_active_workspace (_tmp131_);
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp133_ = wnck_window_is_in_viewport (_tmp129_, _tmp132_);
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp126_ = _tmp133_;
#line 3132 "WindowControl.c"
						} else {
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp126_ = FALSE;
#line 3136 "WindowControl.c"
						}
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_tmp134_ = _tmp126_;
#line 395 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						if (_tmp134_) {
#line 3142 "WindowControl.c"
							WnckWindow* _tmp135_;
#line 396 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							_tmp135_ = w;
#line 396 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							wnck_window_minimize (_tmp135_);
#line 397 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
							g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 3150 "WindowControl.c"
						}
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
						_g_object_unref0 (w);
#line 3154 "WindowControl.c"
					}
#line 394 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
					_g_object_unref0 (_w_list);
#line 3158 "WindowControl.c"
				}
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (window);
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (_window_list);
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				_g_object_unref0 (windows);
#line 399 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				return;
#line 3168 "WindowControl.c"
			}
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_g_object_unref0 (window);
#line 3172 "WindowControl.c"
		}
#line 391 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (_window_list);
#line 3176 "WindowControl.c"
	}
	{
		GeeArrayList* _tmp136_;
		GeeArrayList* _tmp137_;
		GeeArrayList* _window_list;
		GeeArrayList* _tmp138_;
		gint _tmp139_;
		gint _tmp140_;
		gint _window_size;
		gint _window_index;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp136_ = windows;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp137_ = _g_object_ref0 (_tmp136_);
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_list = _tmp137_;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp138_ = _window_list;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp139_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp138_);
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp140_ = _tmp139_;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_size = _tmp140_;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_window_index = -1;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		while (TRUE) {
#line 3205 "WindowControl.c"
			gint _tmp141_;
			gint _tmp142_;
			gint _tmp143_;
			GeeArrayList* _tmp144_;
			gint _tmp145_;
			gpointer _tmp146_ = NULL;
			WnckWindow* window;
			WnckWindow* _tmp147_;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp141_ = _window_index;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_window_index = _tmp141_ + 1;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp142_ = _window_index;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp143_ = _window_size;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			if (!(_tmp142_ < _tmp143_)) {
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
				break;
#line 3226 "WindowControl.c"
			}
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp144_ = _window_list;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp145_ = _window_index;
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp146_ = gee_abstract_list_get ((GeeAbstractList*) _tmp144_, _tmp145_);
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			window = (WnckWindow*) _tmp146_;
#line 403 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp147_ = window;
#line 403 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			plank_services_windows_window_control_center_and_focus_window (_tmp147_);
#line 404 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_g_object_unref0 (window);
#line 3244 "WindowControl.c"
		}
#line 402 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (_window_list);
#line 3248 "WindowControl.c"
	}
#line 355 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_object_unref0 (windows);
#line 3252 "WindowControl.c"
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return _data1_;
#line 3261 "WindowControl.c"
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (_data1_->targetWindow);
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		g_slice_free (Block1Data, _data1_);
#line 3274 "WindowControl.c"
	}
}


static gboolean __lambda2_ (Block1Data* _data1_) {
	gboolean result = FALSE;
	WnckWindow* _tmp0_;
	guint32 _tmp1_;
#line 434 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = _data1_->targetWindow;
#line 434 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = _data1_->time;
#line 434 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_window_activate (_tmp0_, _tmp1_);
#line 435 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	result = FALSE;
#line 435 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 3293 "WindowControl.c"
}


static gboolean ___lambda2__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda2_ (self);
#line 433 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 3302 "WindowControl.c"
}


static void plank_services_windows_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow, GeeArrayList* additional_windows) {
	Block1Data* _data1_;
	WnckWindow* _tmp0_;
	WnckWindow* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeListIterator* _tmp3_ = NULL;
	GeeListIterator* iterator;
	GeeListIterator* _tmp4_;
	WnckWindow* _tmp17_;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	guint32 _tmp21_ = 0U;
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (targetWindow != NULL);
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (additional_windows != NULL);
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_data1_->_ref_count_ = 1;
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = targetWindow;
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_object_unref0 (_data1_->targetWindow);
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_data1_->targetWindow = _tmp1_;
#line 413 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = additional_windows;
#line 413 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = gee_abstract_list_list_iterator ((GeeAbstractList*) _tmp2_);
#line 413 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	iterator = _tmp3_;
#line 415 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp4_ = iterator;
#line 415 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	gee_bidir_iterator_last ((GeeBidirIterator*) _tmp4_);
#line 417 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	while (TRUE) {
#line 3347 "WindowControl.c"
		GeeListIterator* _tmp5_;
		gboolean _tmp6_ = FALSE;
		GeeListIterator* _tmp7_;
		gpointer _tmp8_ = NULL;
		WnckWindow* window;
		gboolean _tmp9_ = FALSE;
		WnckWindow* _tmp10_;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp15_;
#line 417 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp5_ = iterator;
#line 417 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp6_ = gee_bidir_iterator_previous ((GeeBidirIterator*) _tmp5_);
#line 417 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		if (!_tmp6_) {
#line 417 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			break;
#line 3365 "WindowControl.c"
		}
#line 418 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp7_ = iterator;
#line 418 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp8_ = gee_iterator_get ((GeeIterator*) _tmp7_);
#line 418 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		window = (WnckWindow*) _tmp8_;
#line 419 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp10_ = window;
#line 419 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp11_ = wnck_window_is_minimized (_tmp10_);
#line 419 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		if (!_tmp11_) {
#line 3379 "WindowControl.c"
			WnckWindow* _tmp12_;
			WnckWindow* _tmp13_;
			gboolean _tmp14_ = FALSE;
#line 419 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp12_ = _data1_->targetWindow;
#line 419 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp13_ = window;
#line 419 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp14_ = plank_services_windows_window_control_windows_share_viewport (_tmp12_, _tmp13_);
#line 419 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp9_ = _tmp14_;
#line 3391 "WindowControl.c"
		} else {
#line 419 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp9_ = FALSE;
#line 3395 "WindowControl.c"
		}
#line 419 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp15_ = _tmp9_;
#line 419 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		if (_tmp15_) {
#line 3401 "WindowControl.c"
			WnckWindow* _tmp16_;
#line 420 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			_tmp16_ = window;
#line 420 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			plank_services_windows_window_control_center_and_focus_window (_tmp16_);
#line 421 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
			g_usleep ((gulong) PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 3409 "WindowControl.c"
		}
#line 417 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (window);
#line 3413 "WindowControl.c"
	}
#line 425 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp17_ = _data1_->targetWindow;
#line 425 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	plank_services_windows_window_control_center_and_focus_window (_tmp17_);
#line 427 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp18_ = additional_windows;
#line 427 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp19_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp18_);
#line 427 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp20_ = _tmp19_;
#line 427 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp20_ <= 1) {
#line 428 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (iterator);
#line 428 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		block1_data_unref (_data1_);
#line 428 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_data1_ = NULL;
#line 428 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		return;
#line 3435 "WindowControl.c"
	}
#line 432 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp21_ = gtk_get_current_event_time ();
#line 432 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_data1_->time = _tmp21_ + PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY;
#line 433 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, PLANK_SERVICES_WINDOWS_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY, ___lambda2__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_object_unref0 (iterator);
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	block1_data_unref (_data1_);
#line 408 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_data1_ = NULL;
#line 3449 "WindowControl.c"
}


static gboolean plank_services_windows_window_control_windows_share_viewport (WnckWindow* first, WnckWindow* second) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	WnckWindow* _tmp1_;
	gboolean _tmp3_;
	WnckWindow* _tmp4_;
	WnckWorkspace* _tmp5_ = NULL;
	WnckWorkspace* _tmp6_;
	WnckWorkspace* _tmp7_;
	WnckWorkspace* _tmp8_;
	WnckWorkspace* _tmp12_;
	WnckWorkspace* _tmp13_;
	WnckWorkspace* wksp;
	WnckWorkspace* _tmp14_;
	GdkRectangle firstGeo = {0};
	GdkRectangle secondGeo = {0};
	WnckWindow* _tmp15_;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	WnckWindow* _tmp20_;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	gint _tmp25_;
	WnckWorkspace* _tmp26_;
	gint _tmp27_ = 0;
	gint _tmp28_;
	WnckWorkspace* _tmp29_;
	gint _tmp30_ = 0;
	gint _tmp31_;
	WnckWorkspace* _tmp32_;
	gint _tmp33_ = 0;
	gint _tmp34_;
	WnckWorkspace* _tmp35_;
	gint _tmp36_ = 0;
	WnckWindow* _tmp37_;
	WnckScreen* _tmp38_ = NULL;
	gint _tmp39_ = 0;
	gint viewportWidth;
	WnckWindow* _tmp40_;
	WnckScreen* _tmp41_ = NULL;
	gint _tmp42_ = 0;
	gint viewportHeight;
	GdkRectangle _tmp43_;
	gint _tmp44_;
	GdkRectangle _tmp45_;
	gint _tmp46_;
	gint _tmp47_;
	gint _tmp48_;
	gint firstViewportX;
	GdkRectangle _tmp49_;
	gint _tmp50_;
	GdkRectangle _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	gint firstViewportY;
	GdkRectangle viewpRect = {0};
	gint _tmp55_;
	gint _tmp56_;
	gint _tmp57_;
	gint _tmp58_;
	GdkRectangle _tmp59_;
	gboolean _tmp60_ = FALSE;
#line 441 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp1_ = first;
#line 441 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp1_ == NULL) {
#line 441 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp0_ = TRUE;
#line 3526 "WindowControl.c"
	} else {
		WnckWindow* _tmp2_;
#line 441 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp2_ = second;
#line 441 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 3533 "WindowControl.c"
	}
#line 441 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = _tmp0_;
#line 441 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp3_) {
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		result = FALSE;
#line 442 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		return result;
#line 3543 "WindowControl.c"
	}
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp4_ = first;
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp5_ = wnck_window_get_workspace (_tmp4_);
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp7_ = _tmp6_;
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp8_ = _tmp7_;
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp8_ == NULL) {
#line 3557 "WindowControl.c"
		WnckWindow* _tmp9_;
		WnckWorkspace* _tmp10_ = NULL;
		WnckWorkspace* _tmp11_;
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp9_ = second;
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp10_ = wnck_window_get_workspace (_tmp9_);
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (_tmp7_);
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp7_ = _tmp11_;
#line 3571 "WindowControl.c"
	}
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp12_ = _tmp7_;
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 444 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wksp = _tmp13_;
#line 445 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp14_ = wksp;
#line 445 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp14_ == NULL) {
#line 446 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		result = FALSE;
#line 446 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (wksp);
#line 446 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_g_object_unref0 (_tmp7_);
#line 446 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		return result;
#line 3591 "WindowControl.c"
	}
#line 448 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	memset (&firstGeo, 0, sizeof (GdkRectangle));
#line 449 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	memset (&secondGeo, 0, sizeof (GdkRectangle));
#line 451 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp15_ = first;
#line 451 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_window_get_geometry (_tmp15_, &_tmp16_, &_tmp17_, &_tmp18_, &_tmp19_);
#line 451 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	firstGeo.x = _tmp16_;
#line 451 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	firstGeo.y = _tmp17_;
#line 451 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	firstGeo.width = _tmp18_;
#line 451 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	firstGeo.height = _tmp19_;
#line 452 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp20_ = second;
#line 452 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_window_get_geometry (_tmp20_, &_tmp21_, &_tmp22_, &_tmp23_, &_tmp24_);
#line 452 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	secondGeo.x = _tmp21_;
#line 452 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	secondGeo.y = _tmp22_;
#line 452 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	secondGeo.width = _tmp23_;
#line 452 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	secondGeo.height = _tmp24_;
#line 454 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp25_ = firstGeo.x;
#line 454 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp26_ = wksp;
#line 454 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp27_ = wnck_workspace_get_viewport_x (_tmp26_);
#line 454 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	firstGeo.x = _tmp25_ + _tmp27_;
#line 455 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp28_ = firstGeo.y;
#line 455 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp29_ = wksp;
#line 455 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp30_ = wnck_workspace_get_viewport_y (_tmp29_);
#line 455 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	firstGeo.y = _tmp28_ + _tmp30_;
#line 457 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp31_ = secondGeo.x;
#line 457 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp32_ = wksp;
#line 457 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp33_ = wnck_workspace_get_viewport_x (_tmp32_);
#line 457 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	secondGeo.x = _tmp31_ + _tmp33_;
#line 458 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp34_ = secondGeo.y;
#line 458 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp35_ = wksp;
#line 458 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp36_ = wnck_workspace_get_viewport_y (_tmp35_);
#line 458 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	secondGeo.y = _tmp34_ + _tmp36_;
#line 460 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp37_ = first;
#line 460 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp38_ = wnck_window_get_screen (_tmp37_);
#line 460 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp39_ = wnck_screen_get_width (_tmp38_);
#line 460 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	viewportWidth = _tmp39_;
#line 461 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp40_ = first;
#line 461 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp41_ = wnck_window_get_screen (_tmp40_);
#line 461 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp42_ = wnck_screen_get_height (_tmp41_);
#line 461 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	viewportHeight = _tmp42_;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp43_ = firstGeo;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp44_ = _tmp43_.x;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp45_ = firstGeo;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp46_ = _tmp45_.width;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp47_ = viewportWidth;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp48_ = viewportWidth;
#line 463 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	firstViewportX = ((_tmp44_ + (_tmp46_ / 2)) / _tmp47_) * _tmp48_;
#line 464 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp49_ = firstGeo;
#line 464 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp50_ = _tmp49_.y;
#line 464 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp51_ = firstGeo;
#line 464 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp52_ = _tmp51_.height;
#line 464 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp53_ = viewportHeight;
#line 464 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp54_ = viewportHeight;
#line 464 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	firstViewportY = ((_tmp50_ + (_tmp52_ / 2)) / _tmp53_) * _tmp54_;
#line 466 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	memset (&viewpRect, 0, sizeof (GdkRectangle));
#line 467 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp55_ = firstViewportX;
#line 467 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	viewpRect.x = _tmp55_;
#line 468 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp56_ = firstViewportY;
#line 468 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	viewpRect.y = _tmp56_;
#line 469 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp57_ = viewportWidth;
#line 469 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	viewpRect.width = _tmp57_;
#line 470 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp58_ = viewportHeight;
#line 470 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	viewpRect.height = _tmp58_;
#line 472 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp59_ = secondGeo;
#line 472 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp60_ = gdk_rectangle_intersect (&viewpRect, &_tmp59_, NULL);
#line 472 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	result = _tmp60_;
#line 472 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_object_unref0 (wksp);
#line 472 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_g_object_unref0 (_tmp7_);
#line 472 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return result;
#line 3727 "WindowControl.c"
}


static void plank_services_windows_window_control_center_and_focus_window (WnckWindow* w) {
	guint32 _tmp0_ = 0U;
	guint32 time;
	gboolean _tmp1_ = FALSE;
	WnckWindow* _tmp2_;
	WnckWorkspace* _tmp3_ = NULL;
	gboolean _tmp9_;
	WnckWindow* _tmp13_;
	gboolean _tmp14_ = FALSE;
	WnckWindow* _tmp17_;
	guint32 _tmp18_;
#line 475 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (w != NULL);
#line 477 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = gtk_get_current_event_time ();
#line 477 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	time = _tmp0_;
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp2_ = w;
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp3_ = wnck_window_get_workspace (_tmp2_);
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp3_ != NULL) {
#line 3754 "WindowControl.c"
		WnckWindow* _tmp4_;
		WnckWorkspace* _tmp5_ = NULL;
		WnckWindow* _tmp6_;
		WnckScreen* _tmp7_ = NULL;
		WnckWorkspace* _tmp8_ = NULL;
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp4_ = w;
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp5_ = wnck_window_get_workspace (_tmp4_);
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp6_ = w;
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp7_ = wnck_window_get_screen (_tmp6_);
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp8_ = wnck_screen_get_active_workspace (_tmp7_);
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp1_ = _tmp5_ != _tmp8_;
#line 3772 "WindowControl.c"
	} else {
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp1_ = FALSE;
#line 3776 "WindowControl.c"
	}
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp9_ = _tmp1_;
#line 478 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp9_) {
#line 3782 "WindowControl.c"
		WnckWindow* _tmp10_;
		WnckWorkspace* _tmp11_ = NULL;
		guint32 _tmp12_;
#line 479 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp10_ = w;
#line 479 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp11_ = wnck_window_get_workspace (_tmp10_);
#line 479 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp12_ = time;
#line 479 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		wnck_workspace_activate (_tmp11_, _tmp12_);
#line 3794 "WindowControl.c"
	}
#line 481 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp13_ = w;
#line 481 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp14_ = wnck_window_is_minimized (_tmp13_);
#line 481 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	if (_tmp14_) {
#line 3802 "WindowControl.c"
		WnckWindow* _tmp15_;
		guint32 _tmp16_;
#line 482 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp15_ = w;
#line 482 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		_tmp16_ = time;
#line 482 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
		wnck_window_unminimize (_tmp15_, _tmp16_);
#line 3811 "WindowControl.c"
	}
#line 484 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp17_ = w;
#line 484 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp18_ = time;
#line 484 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_window_activate_transient (_tmp17_, _tmp18_);
#line 3819 "WindowControl.c"
}


void plank_services_windows_window_control_get_easy_geometry (WnckWindow* w, GdkRectangle* result) {
	GdkRectangle geo = {0};
	WnckWindow* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 487 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	g_return_if_fail (w != NULL);
#line 489 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	memset (&geo, 0, sizeof (GdkRectangle));
#line 491 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	_tmp0_ = w;
#line 491 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	wnck_window_get_geometry (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 491 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	geo.x = _tmp1_;
#line 491 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	geo.y = _tmp2_;
#line 491 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	geo.width = _tmp3_;
#line 491 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	geo.height = _tmp4_;
#line 493 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	*result = geo;
#line 493 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	return;
#line 3850 "WindowControl.c"
}


static void plank_services_windows_window_control_class_init (PlankServicesWindowsWindowControlClass * klass) {
#line 41 "/builddir/build/BUILD/plank-0.2.0.834/lib/Services/WindowControl.vala"
	plank_services_windows_window_control_parent_class = g_type_class_peek_parent (klass);
#line 3857 "WindowControl.c"
}


static void plank_services_windows_window_control_instance_init (PlankServicesWindowsWindowControl * self) {
}


GType plank_services_windows_window_control_get_type (void) {
	static volatile gsize plank_services_windows_window_control_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_windows_window_control_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankServicesWindowsWindowControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_services_windows_window_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankServicesWindowsWindowControl), 0, (GInstanceInitFunc) plank_services_windows_window_control_instance_init, NULL };
		GType plank_services_windows_window_control_type_id;
		plank_services_windows_window_control_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankServicesWindowsWindowControl", &g_define_type_info, 0);
		g_once_init_leave (&plank_services_windows_window_control_type_id__volatile, plank_services_windows_window_control_type_id);
	}
	return plank_services_windows_window_control_type_id__volatile;
}



